/* Compilation flags for the source code.

If you want some specific feature remove the remarks, add
remarks if don't. Or change the macro value, if is the case. */



// Enable assembler code. If don't, is used only C code.
// Some times C is faster than my ASM...
//#define COMP_ASM



// What print out in the scenery load process with CFileTXE
// 0 - no output
// 1 - show file names beeing load and error messages
// 2 - show same information from previous item (1), and blocks found
// option 2 is good for TXE debug.
#define COMP_SHOWLOADING 1



// Comment to disable wait retrace test (make images output faster and
// a bit ugly for animations).
//#define COMP_WAIT_RETRACE



// Enable the colored light system. If don't, use polygons without
// shadows. This flag just change the polygon draw functions,
// the memory allocation for light tables and all the rest
// continue existing without flag change.
// Incrise speed very much, if disabled.
#define COMP_LIGHTS



// Comment to draw textured polys with flat shades - faster (and ugly).
// Uncomment to draw with insterpolated shades (like gouraud) - slower.
// If COMP_LIGHTS disabled this flag is ignored.
#define COMP_RENDER_INTERPOLATED_LIGHT



// Use light system only with shadows between dark and be texture
// colors. If you add remarks the code used generate light tables
// that go from dark to texture color and than to light source color.
// You need delete the light table files (normaly all: *.LTB) to
// force the regeneration with the new configuration.
// The light level indexes change:
//  with hilights: 0..0.5 (normal)   0.5..1 (hi)
//  with lights:   0..1 (normal)
// If COMP_LIGHTS disabled this flag is ignored.
// Don't comment else you know what are doing.
#define COMP_HILIGHTS
