/* Test CBPN and CNeuron */



#include <stdio.h>

#include "../3dfc.h"



main ()
{
   CBPN
      oNetwork;

   // insert training vectors

   printf ( "inserting vectors for XOR...\n" );

   // try create new training vectors
   CNodeList
      *poVector0 = new CNodeList;
   if ( poVector0 == NULL ) {
      printf ( "no memory!\n" );
      return 0;
   }
   CNodeList
      *poVector1 = new CNodeList;
   if ( poVector1 == NULL ) {
      printf ( "no memory!\n" );
      return 0;
   }
   CNodeList
      *poVector2 = new CNodeList;
   if ( poVector2 == NULL ) {
      printf ( "no memory!\n" );
      return 0;
   }
   CNodeList
      *poVector3 = new CNodeList;
   if ( poVector3 == NULL ) {
      printf ( "no memory!\n" );
      return 0;
   }

   // add elements to training vectors
   poVector0->m_oList.mSetEnd ( new CNodeFloat ( +1 ) );
   poVector0->m_oList.mSetEnd ( new CNodeFloat ( +1 ) );
   poVector1->m_oList.mSetEnd ( new CNodeFloat ( +1 ) );
   poVector1->m_oList.mSetEnd ( new CNodeFloat ( -1 ) );
   poVector2->m_oList.mSetEnd ( new CNodeFloat ( -1 ) );
   poVector2->m_oList.mSetEnd ( new CNodeFloat ( +1 ) );
   poVector3->m_oList.mSetEnd ( new CNodeFloat ( -1 ) );
   poVector3->m_oList.mSetEnd ( new CNodeFloat ( -1 ) );

   // add training vectors to network
   oNetwork.m_oInputs.mSetEnd ( poVector0 );
   oNetwork.m_oInputs.mSetEnd ( poVector1 );
   oNetwork.m_oInputs.mSetEnd ( poVector2 );
   oNetwork.m_oInputs.mSetEnd ( poVector3 );

   // try create new desaired values for each output neuron
   CNodeList
      *poDesired0 = new CNodeList;
   if ( poDesired0 == NULL ) {
      printf ( "no memory!\n" );
      return 0;
   }
   CNodeList
      *poDesired1 = new CNodeList;
   if ( poDesired1 == NULL ) {
      printf ( "no memory!\n" );
      return 0;
   }
   CNodeList
      *poDesired2 = new CNodeList;
   if ( poDesired2 == NULL ) {
      printf ( "no memory!\n" );
      return 0;
   }
   CNodeList
      *poDesired3 = new CNodeList;
   if ( poDesired3 == NULL ) {
      printf ( "no memory!\n" );
      return 0;
   }

   // add desired elements for traing vectors (one value per output neuron)
   poDesired0->m_oList.mSetEnd ( new CNodeFloat ( -1 ) );
   poDesired1->m_oList.mSetEnd ( new CNodeFloat ( +1 ) );
   poDesired2->m_oList.mSetEnd ( new CNodeFloat ( +1 ) );
   poDesired3->m_oList.mSetEnd ( new CNodeFloat ( -1 ) );

   // add desired answers for respective training vector
   oNetwork.m_oD.mSetEnd ( poDesired0 );
   oNetwork.m_oD.mSetEnd ( poDesired1 );
   oNetwork.m_oD.mSetEnd ( poDesired2 );
   oNetwork.m_oD.mSetEnd ( poDesired3 );

   // insert layers

   printf ( "Enter number of neurons in hiden layer: " );
   INT
      nNumNeurons;
   scanf ( "%d", &nNumNeurons );
   printf ( "inserting layers... %d neurons in hiden layer and 1 in output layer.\n", nNumNeurons );

   // add hiden layer
   oNetwork.mAddLayer ( nNumNeurons );

   // add output layer (is always the last layer inserted)
   oNetwork.mAddLayer ( 1 );

   BOOL
      bEnd = FALSE;
   while ( ! bEnd ) {
      
      printf ( "\ncommand (h for help): " );
      char
         aszCmd [ 100 ];
      scanf ( "%s", aszCmd );

      switch ( aszCmd [ 0 ] ) {

         case 'H':
         case 'h':
            printf ( "s - Set rate\n" );
            printf ( "g - Get rate\n" );
            printf ( "t - Train network\n" );
            printf ( "o - Output propagation\n" );
            printf ( "a - output propagation for All vectors\n" );
            printf ( "w - show Weights\n" );
            printf ( "i - Init random weights\n" );
            printf ( "e - Enter weights by keyboard\n" );
            printf ( "f - save to File (adaptation rate, weights and nets)\n" );
            printf ( "l - Load from file (adaptation rate, weights and nets)\n" );
            printf ( "q - Quit\n" );
            break;

         case 'Q':
         case 'q':
            bEnd = TRUE;
            break;

         case 'F':
         case 'f':
            {
               CString
                  oszFile ( 300 );
               printf ( "Enter the file name: " );
               scanf ( "%s", (char*) oszFile );
               printf ( "Saving...\n" );
               // try save
               if ( ! oNetwork.mSave ( oszFile ) )
                  printf ( "save error.\n" );
            }
            break;

         case 'L':
         case 'l':
            {
               CString
                  oszFile ( 300 );
               printf ( "Enter the file name: " );
               scanf ( "%s", (char*) oszFile );
               printf ( "Loading...\n" );
               // try load
               if ( ! oNetwork.mLoad ( oszFile ) )
                  printf ( "load error.\n" );
            }
            break;
         
         case 'T':
         case 't':
            {
               DWORD
                  dwInteractions = 0;
               printf ( "Number of interactions: " );
               scanf ( "%d", &dwInteractions );
               printf ( "training...\n" );
               oNetwork.mTrain ( dwInteractions );
            }
            break;

         case 'S':
         case 's':
            {
               float
                  fRate = 0;
               printf ( "New rate: " );
               scanf ( "%f", &fRate );
               oNetwork.mSetRate ( fRate );
            }
            break;

         case 'G':
         case 'g':
            printf ( "Rate: %f\n", oNetwork.mRetRate () );
            break;
         
         case 'O':
         case 'o':
            {
               DWORD
                  dwVector = 0;
               printf ( "Index of input vector: " );
               scanf ( "%d", &dwVector );
               oNetwork.mPropagate ( dwVector );

               oNetwork.m_oOutput.mSelectStart ();
               while ( oNetwork.m_oOutput.mRetExistSelection () ) {
                  printf ( "%f\n", ( (CNodeNeuron*) oNetwork.m_oOutput.mRetSelected () ) -> m_oNeuron.mRetPropagationValue () );
                  oNetwork.m_oOutput.mSelectNext ();
               }
            }
            break;
         
         case 'A':
         case 'a':
            {
               for ( DWORD dwcVect = 0; dwcVect < 4; dwcVect ++ ) {
               
                  printf ( "propagation with input vector %d: ", dwcVect );
                  oNetwork.mPropagate ( dwcVect );

                  oNetwork.m_oOutput.mSelectStart ();
                  while ( oNetwork.m_oOutput.mRetExistSelection () ) {
                     printf ( "%f\n", ( (CNodeNeuron*) oNetwork.m_oOutput.mRetSelected () ) -> m_oNeuron.mRetPropagationValue () );
                     oNetwork.m_oOutput.mSelectNext ();
                  }
               }
            }
            break;
         
         case 'W':
         case 'w':
            {
               DWORD
                  dwLayer = 0;
               // for each layer
               oNetwork.m_oLayers.mSelectStart ();
               // while exist layer (selection not NULL)
               while ( oNetwork.m_oLayers.mRetExistSelection () ) {

                  printf ( "Layer %d.\n", dwLayer );

                  DWORD
                     dwNeuron = 0;
                  // for each neuron in layer
                  CNodeList
                     *poLayer = (CNodeList*) oNetwork.m_oLayers.mRetSelected ();
                  poLayer->m_oList.mSelectStart ();
                  // while exist neuron (selection not NULL)
                  while ( poLayer->m_oList.mRetExistSelection () ) {

                     printf ( " Neuron %d.\n", dwNeuron );
                     // point neuron
                     CNodeNeuron
                        *poNeuron = (CNodeNeuron*) poLayer->m_oList.mRetSelected ();

                     // for weight in neuron
                     CList
                        *poWeights = (CList*) &poNeuron->m_oNeuron.m_oW;
                     poWeights->mSelectStart ();
                     // while exist weight (selection not NULL)
                     while ( poWeights->mRetExistSelection () ) {
                        printf ( "  %f", ( (CNodeFloat*) poWeights->mRetSelected () )->m_fValue );
                        poWeights->mSelectNext ();
                     }

                     // select next neuron in layer
                     poLayer->m_oList.mSelectNext ();
                     dwNeuron ++;
                     printf ( "\n" );
                  }

                  // select next layer
                  oNetwork.m_oLayers.mSelectNext ();
                  dwLayer ++;
               }
            }
            break;
         
         case 'E':
         case 'e':
            {
               DWORD
                  dwLayer = 0;

               printf ( "Enter weight values.\n" );

               // for each layer
               oNetwork.m_oLayers.mSelectStart ();
               // while exist layer (selection not NULL)
               while ( oNetwork.m_oLayers.mRetExistSelection () ) {

                  printf ( "Layer %d.\n", dwLayer );

                  DWORD
                     dwNeuron = 0;
                  // for each neuron in layer
                  CNodeList
                     *poLayer = (CNodeList*) oNetwork.m_oLayers.mRetSelected ();
                  poLayer->m_oList.mSelectStart ();
                  // while exist neuron (selection not NULL)
                  while ( poLayer->m_oList.mRetExistSelection () ) {

                     printf ( " Neuron %d.\n", dwNeuron );
                     // point neuron
                     CNodeNeuron
                        *poNeuron = (CNodeNeuron*) poLayer->m_oList.mRetSelected ();

                     // for weight in neuron
                     CList
                        *poWeights = (CList*) &poNeuron->m_oNeuron.m_oW;
                     poWeights->mSelectStart ();
                     // while exist weight (selection not NULL)
                     while ( poWeights->mRetExistSelection () ) {
                        printf ( "  value: " );
                        float
                           fNew;
                        scanf ( "%f", &fNew );
                        ( (CNodeFloat*) poWeights->mRetSelected () )->m_fValue = fNew;
                        poWeights->mSelectNext ();
                     }

                     // select next neuron in layer
                     poLayer->m_oList.mSelectNext ();
                     dwNeuron ++;
                     printf ( "\n" );
                  }

                  // select next layer
                  oNetwork.m_oLayers.mSelectNext ();
                  dwLayer ++;
               }
            }
            break;
         
         case 'I':
         case 'i':
            {
               DWORD
                  dwLayer = 0;

               // for each layer
               oNetwork.m_oLayers.mSelectStart ();
               // while exist layer (selection not NULL)
               while ( oNetwork.m_oLayers.mRetExistSelection () ) {

                  DWORD
                     dwNeuron = 0;
                  // for each neuron in layer
                  CNodeList
                     *poLayer = (CNodeList*) oNetwork.m_oLayers.mRetSelected ();
                  poLayer->m_oList.mSelectStart ();
                  // while exist neuron (selection not NULL)
                  while ( poLayer->m_oList.mRetExistSelection () ) {

                     // point neuron
                     CNodeNeuron
                        *poNeuron = (CNodeNeuron*) poLayer->m_oList.mRetSelected ();

                     // for each weight in neuron
                     CList
                        *poWeights = (CList*) &poNeuron->m_oNeuron.m_oW;
                     poWeights->mSelectStart ();
                     // while exist weight (selection not NULL)
                     while ( poWeights->mRetExistSelection () ) {
                        ( (CNodeFloat*) poWeights->mRetSelected () )->m_fValue = ( (float) ( random () % 1000 ) / 1000 ) - 0.5;
                        poWeights->mSelectNext ();
                     }

                     // select next neuron in layer
                     poLayer->m_oList.mSelectNext ();
                     dwNeuron ++;
                  }

                  // select next layer
                  oNetwork.m_oLayers.mSelectNext ();
                  dwLayer ++;
               }
            }
            break;
      }
   }
}
