/* Test CBPN and CNeuron */



#include <stdio.h>

#include "../3dfc.h"



main ()
{
   CBPN
      oNetwork;

   // insert training vectors

   printf ( "inserting vectors for AND...\n" );

   // try create new training vectors
   CNodeList
      *poVector0 = new CNodeList;
   if ( poVector0 == NULL ) {
      printf ( "no memory!\n" );
      return 0;
   }
   CNodeList
      *poVector1 = new CNodeList;
   if ( poVector1 == NULL ) {
      printf ( "no memory!\n" );
      return 0;
   }
   CNodeList
      *poVector2 = new CNodeList;
   if ( poVector2 == NULL ) {
      printf ( "no memory!\n" );
      return 0;
   }
   CNodeList
      *poVector3 = new CNodeList;
   if ( poVector3 == NULL ) {
      printf ( "no memory!\n" );
      return 0;
   }

   // add elements to training vectors
   poVector0->m_oList.mSetEnd ( new CNodeFloat ( +1 ) );
   poVector0->m_oList.mSetEnd ( new CNodeFloat ( +1 ) );
   poVector1->m_oList.mSetEnd ( new CNodeFloat ( +1 ) );
   poVector1->m_oList.mSetEnd ( new CNodeFloat ( -1 ) );
   poVector2->m_oList.mSetEnd ( new CNodeFloat ( -1 ) );
   poVector2->m_oList.mSetEnd ( new CNodeFloat ( +1 ) );
   poVector3->m_oList.mSetEnd ( new CNodeFloat ( -1 ) );
   poVector3->m_oList.mSetEnd ( new CNodeFloat ( -1 ) );

   // add training vectors to network
   oNetwork.m_oInputs.mSetEnd ( poVector0 );
   oNetwork.m_oInputs.mSetEnd ( poVector1 );
   oNetwork.m_oInputs.mSetEnd ( poVector2 );
   oNetwork.m_oInputs.mSetEnd ( poVector3 );

   // try create new desaired values for each output neuron
   CNodeList
      *poDesired0 = new CNodeList;
   if ( poDesired0 == NULL ) {
      printf ( "no memory!\n" );
      return 0;
   }
   CNodeList
      *poDesired1 = new CNodeList;
   if ( poDesired1 == NULL ) {
      printf ( "no memory!\n" );
      return 0;
   }
   CNodeList
      *poDesired2 = new CNodeList;
   if ( poDesired2 == NULL ) {
      printf ( "no memory!\n" );
      return 0;
   }
   CNodeList
      *poDesired3 = new CNodeList;
   if ( poDesired3 == NULL ) {
      printf ( "no memory!\n" );
      return 0;
   }

   // add desired elements for traing vectors (one value per output neuron)
   poDesired0->m_oList.mSetEnd ( new CNodeFloat ( +1 ) );
   poDesired1->m_oList.mSetEnd ( new CNodeFloat ( -1 ) );
   poDesired2->m_oList.mSetEnd ( new CNodeFloat ( -1 ) );
   poDesired3->m_oList.mSetEnd ( new CNodeFloat ( -1 ) );

   // add desired answers for respective training vector
   oNetwork.m_oD.mSetEnd ( poDesired0 );
   oNetwork.m_oD.mSetEnd ( poDesired1 );
   oNetwork.m_oD.mSetEnd ( poDesired2 );
   oNetwork.m_oD.mSetEnd ( poDesired3 );

   // insert layers

   printf ( "inserting layers... 2 neurons in hiden layer, 1 in output layer\n" );

   // add hiden layer
   oNetwork.mAddLayer ( 2 );

   // add output layer (is always the last layer inserted)
   oNetwork.mAddLayer ( 1 );

   // show adaptation rate
   printf ( "adaptation rate: %f\n", oNetwork.mRetRate () );

   // train network

   // make propagation
   printf ( "training with 50 interactions...\n" );
   oNetwork.mTrain ( 50 );

   // show output

   printf ( "output...\n" );

   for ( INT ncVect = 0; ncVect < 4; ncVect ++ ) {
      
      printf ( " propagation with input vector %d: ", ncVect );
      oNetwork.mPropagate ( ncVect );

      oNetwork.m_oOutput.mSelectStart ();
      while ( oNetwork.m_oOutput.mRetExistSelection () ) {
         printf ( "%f\n", ( (CNodeNeuron*) oNetwork.m_oOutput.mRetSelected () ) -> m_oNeuron.mRetPropagationValue () );
         oNetwork.m_oOutput.mSelectNext ();
      }
   }
}
