/* Test CDraw basic 2D primitives and flat polys */



#include <stdio.h>

#include "../3dfc.h"



main ()
{
   // load palette
   CMem
      oPal;
   CFilePCX
      oFile ( "texture.pcx", oPal );

   // init graphics and program palette
   CScreen
      oS;
   oS.mCreate ( MODE_MCGA );
   oS.mSetPalette ( oPal );

   // define frame buffer
   CMem
      oFrameBuffer ( 320 * 200 );


   // define light table (need to draw any texture)
   CLightTable
      oLgT;
   oLgT.mCreate ( oPal, 1, 1, 1, 1 );

   CDraw
      oDraw ( oLgT, 320, 200, oFrameBuffer );

   // TEST LINE AND PIXEL DRAW

   // draw lines
   oDraw.mClear ( 0 );
   oDraw.mLine ( 10, 12, 50, 20, 152 );
   oDraw.mLine ( 100, 100, 120, 160, 140 );
   oDraw.mLine ( 100, 50, 200, 20, 132 );
   oDraw.mLine ( 150, 100, 130, 180, 122 );
   oDraw.mLine ( 130, 100, 190, 100, 122 );
   oDraw.mLine ( 160, 40, 160, 160, 122 );

   oDraw.mSetPixel ( 10, 12, 122 );
   oDraw.mSetPixel ( 50, 20, 122 );
   oDraw.mSetPixel ( 100, 100, 122 );
   oDraw.mSetPixel ( 120, 160, 122 );
   oDraw.mSetPixel ( 100, 50, 122 );
   oDraw.mSetPixel ( 200, 20, 122 );
   oDraw.mSetPixel ( 150, 100, 122 );
   oDraw.mSetPixel ( 130, 180, 122 );
   oDraw.mSetPixel ( 130, 100, 122 );
   oDraw.mSetPixel ( 190, 100, 122 );
   oDraw.mSetPixel ( 160, 40, 122 );
   oDraw.mSetPixel ( 160, 160, 122 );

   // show frame buffer on screen
   oS.mShow ( oFrameBuffer );

   getchar ();

   oDraw.mClear ( 0 );
   oDraw.mLine ( 50, 20, 10, 12, 152 );
   oDraw.mLine ( 120, 160, 100, 100, 140 );
   oDraw.mLine ( 200, 20, 100, 50, 132 );
   oDraw.mLine ( 130, 180, 150, 100, 122 );
   oDraw.mLine ( 190, 100, 130, 100, 122 );
   oDraw.mLine ( 160, 160, 160, 40, 122 );

   oDraw.mSetPixel ( 10, 12, 122 );
   oDraw.mSetPixel ( 50, 20, 122 );
   oDraw.mSetPixel ( 100, 100, 122 );
   oDraw.mSetPixel ( 120, 160, 122 );
   oDraw.mSetPixel ( 100, 50, 122 );
   oDraw.mSetPixel ( 200, 20, 122 );
   oDraw.mSetPixel ( 150, 100, 122 );
   oDraw.mSetPixel ( 130, 180, 122 );
   oDraw.mSetPixel ( 130, 100, 122 );
   oDraw.mSetPixel ( 190, 100, 122 );
   oDraw.mSetPixel ( 160, 40, 122 );
   oDraw.mSetPixel ( 160, 160, 122 );

   // show frame buffer on screen
   oS.mShow ( oFrameBuffer );

   getchar ();

   // TEST FLAT POLYGON DRAW

   // draw polygons with only 4 vertex
   oDraw.mClear ( 20 );
   oDraw.mFlatPolygon4 (  50, 150,  120, 110,  110, 30,  60, 40,  152 );
   oDraw.mFlatPolygon4 ( 150, 150,  200, 140,  190, 30,  160, 99,  152 );

   oDraw.mSetPixel ( 50, 150, 122 );
   oDraw.mSetPixel ( 120, 110, 122 );
   oDraw.mSetPixel ( 110, 30, 122 );
   oDraw.mSetPixel ( 60, 40, 122 );
   oDraw.mSetPixel ( 150, 150, 122 );
   oDraw.mSetPixel ( 200, 140, 122 );
   oDraw.mSetPixel ( 190, 30, 122 );
   oDraw.mSetPixel ( 160, 99, 122 );

   // show frame buffer on screen
   oS.mShow ( oFrameBuffer );

   getchar ();

   oDraw.mClear ( 20 );

   // define polygons vertex
   tagXY
      astPol1 [ 4 ],
      astPol2 [ 3 ];
   astPol1 [ 0 ].nX =  50;
   astPol1 [ 0 ].nY = 150;
   astPol1 [ 1 ].nX = 120;
   astPol1 [ 1 ].nY = 110;
   astPol1 [ 2 ].nX = 110;
   astPol1 [ 2 ].nY = 30;
   astPol1 [ 3 ].nX = 60;
   astPol1 [ 3 ].nY = 40;

   astPol2 [ 0 ].nX = 150;
   astPol2 [ 0 ].nY = 250;
   astPol2 [ 1 ].nX = 360;
   astPol2 [ 1 ].nY = 140;
   astPol2 [ 2 ].nX = 160;
   astPol2 [ 2 ].nY = -99;

   oDraw.mFlatPolygon ( astPol1, 4, 152 );
   oDraw.mFlatPolygon ( astPol2, 3, 157 );

   // show frame buffer on screen
   oS.mShow ( oFrameBuffer );

   getchar ();
}
