/* Test CDrawClip */



#include <stdio.h>

#include "../3dfc.h"



main ()
{
   // TEST POLYGON DRAW WITH CLIP EDGE BUFFER

   // load bitmap and palette
   CTexture
      oTx;
   CMem
      oPal;
   CFilePCX
      oFile ( "texture.pcx", oTx, oPal );

   // define textured polygon
   tagXY
      astPol [ 4 ],
      astTex [ 4 ];
   // poly vertexes
   astPol [ 0 ].nX = 120;
   astPol [ 0 ].nY = 150;
   astPol [ 1 ].nX = 200;
   astPol [ 1 ].nY = 160;
   astPol [ 2 ].nX = 200;
   astPol [ 2 ].nY = 55;
   astPol [ 3 ].nX = 150;
   astPol [ 3 ].nY = 50;
   // texture vertexes
   astTex [ 0 ].nX = 0;
   astTex [ 0 ].nY = 0;
   astTex [ 1 ].nX = 0;
   astTex [ 1 ].nY = oTx.m_nHeight - 1;
   astTex [ 2 ].nX = oTx.m_nWidth - 1;
   astTex [ 2 ].nY = oTx.m_nHeight - 1;
   astTex [ 3 ].nX = oTx.m_nWidth - 1;
   astTex [ 3 ].nY = 0;

   // make a light table
   CLightTable
      oLgT ( oPal, 1, 1, 1, 1 );

   // define and clear frame buffer
   CMem
      oFrameBuffer ( 320 * 200 );
   CDraw
      oDrawClip ( oLgT, 320, 200, oFrameBuffer );
   oDrawClip.mClear ( 20 );

   // declare clip buffer
   tagInterval
      astClipBuffer [ 200 ];
   // the rectangle circunscribe clip buffer
   tagRectangle
      stClipBox;
   stClipBox.nStartX = 0;
   stClipBox.nStartY = 0;
   stClipBox.nEndX = 319;
   stClipBox.nEndY = 199;

   // reset clip buffer values
   oDrawClip.mResetClipEdgeBuffer ( astClipBuffer );

   // draw original polygon
   oDrawClip.mTexturedPolygon ( astPol, astTex, 4, oTx, astClipBuffer );

   // init graphics, program palette and show frame buffer
   CScreen
      oS;
   oS.mCreate ( MODE_MCGA );
   oS.mSetPalette ( oPal );

   oS.mShow ( oFrameBuffer );

   getchar ();

   oDrawClip.mClear ( 0 );

   // define clip polygon vertexes
   tagXY
      astClipPol [ 4 ];
   astClipPol [ 0 ].nX = 160;
   astClipPol [ 0 ].nY = 50;
   astClipPol [ 1 ].nX = 80;
   astClipPol [ 1 ].nY = 100;
   astClipPol [ 2 ].nX = 160;
   astClipPol [ 2 ].nY = 150;
   astClipPol [ 3 ].nX = 270;
   astClipPol [ 3 ].nY = 100;

   // set clip edge buffer using a clip polygon
   oDrawClip.mSetClipEdgeBuffer ( astClipPol, 4, astClipBuffer, stClipBox );

   // draw a clipped texture mapped polygon
   oDrawClip.mTexturedPolygon ( astPol, astTex, 4, oTx, astClipBuffer );

   // show clip grid
   for ( INT ncC = 0; ncC < 200; ncC ++ ) {
      oDrawClip.mSetPixel ( astClipBuffer [ ncC ].nStart, ncC, 160 );
      oDrawClip.mSetPixel ( astClipBuffer [ ncC ].nEnd, ncC, 165 );
   }

   oS.mShow ( oFrameBuffer );

   getchar ();
}
