/* Test CDraw polys with gouraud shading like */



#include <stdio.h>

#include "../3dfc.h"



main ()
{
   // init graphics
   CScreen
      oS;
   oS.mCreate ( MODE_MCGA );

   // set palette
   CMem
      oPal ( 256 * 3 );
   for ( INT ncP = 0; ncP < 64; ncP ++ ) {
      oPal.m_payMem [ ncP * 3 + 0 ] = ncP / 2;
      oPal.m_payMem [ ncP * 3 + 1 ] = ncP;
      oPal.m_payMem [ ncP * 3 + 2 ] = ncP;
   }
   /* make printf output visible:
   * ( oPal.m_payMem + 7 * 3 + 0 ) = 50;
   * ( oPal.m_payMem + 7 * 3 + 1 ) = 50;
   * ( oPal.m_payMem + 7 * 3 + 2 ) = 50;*/
   oS.mSetPalette ( oPal );

   // define light table
   CLightTable
      oLgT;
   oLgT.mCreate ( oPal, 1, 1, 1, 1 );

   // define frame buffer
   CMem
      oFrameBuffer ( 320 * 200 );

   CDraw
      oDraw ( oLgT, 320, 200, oFrameBuffer );

   oDraw.mClear ( 20 );

   // define polygons vertex
   tagXY
      astPol1 [ 4 ];
   astPol1 [ 0 ].nX =  50;
   astPol1 [ 0 ].nY = 150;
   astPol1 [ 1 ].nX = 120;
   astPol1 [ 1 ].nY = 110;
   astPol1 [ 2 ].nX = 110;
   astPol1 [ 2 ].nY = 30;
   astPol1 [ 3 ].nX = 60;
   astPol1 [ 3 ].nY = 40;
   
   // define vertex colors
   BYTE
      ayColors [] = { 0, 32, 64, 32 };

   oDraw.mIntLgtPolygon ( astPol1, ayColors, 4 );

   // show frame buffer on screen
   oS.mShow ( oFrameBuffer );

   getchar ();
}
