/* Test CDraw polys with interpolated shading in vertexes (like gouraud)
and textures */



#include <stdio.h>

#include "../3dfc.h"


main ()
{
   // load palette and bitmap
   CMem
      oPal;
   CTexture
      oTx1;
   CFilePCX
      oFile ( "texture.pcx", oTx1, oPal );

   printf ( "Before run this demo verify compiling flags in config.h,\n" );
   printf ( "lights must be enabled.\n" );
   getchar ();

   printf ( "Building light tables, pleace wait...\n" );

   // define light table (need to draw any texture)
   CLightTable
      oLgTWhite,
      oLgTYellow;
   oLgTWhite.mCreate ( oPal, 16, 1, 1, 1 );
   oLgTYellow.mCreate ( oPal, 16, 1, 0.6, 0 );

   // init graphics and program palette
   CScreen
      oS;
   oS.mCreate ( MODE_MCGA );
   /* make printf output visible:
   * ( oPal.m_payMem + 7 * 3 + 0 ) = 50;
   * ( oPal.m_payMem + 7 * 3 + 1 ) = 50;
   * ( oPal.m_payMem + 7 * 3 + 2 ) = 50;*/
   oS.mSetPalette ( oPal );

   // define frame buffer
   CMem
      oFrameBuffer ( 320 * 200 );

   CDraw
      oDraw ( oLgTWhite, 320, 200, oFrameBuffer );

   oDraw.mClear ( 0 );

   // define polygon and texture vertexes
   tagXY
      astPol [ 4 ],
      astTex [ 4 ];
   astPol [ 0 ].nX = 120;
   astPol [ 0 ].nY = 150;
   astPol [ 1 ].nX = 200;
   astPol [ 1 ].nY = 160;
   astPol [ 2 ].nX = 200;
   astPol [ 2 ].nY = 55;
   astPol [ 3 ].nX = 100;
   astPol [ 3 ].nY = 50;

   astTex [ 0 ].nX = 0;
   astTex [ 0 ].nY = 0;
   astTex [ 1 ].nX = 0;
   astTex [ 1 ].nY = oTx1.m_nHeight - 1;
   astTex [ 2 ].nX = oTx1.m_nWidth - 1;
   astTex [ 2 ].nY = oTx1.m_nHeight - 1;
   astTex [ 3 ].nX = oTx1.m_nWidth - 1;
   astTex [ 3 ].nY = 0;
   
   // define vertex colors
   float
      afLightLevels [] = { 0.25, 1, 0.1, 0.6 };

   oDraw.mIntLgtTexturedPolygon ( astPol, astTex, afLightLevels, 4, oTx1, NULL );

   // show frame buffer on screen
   oS.mShow ( oFrameBuffer );

   getchar ();

   oDraw.mClear ( 100 );

   // change light table
   oDraw.m_poLightTable = &oLgTYellow;
   
   // define new vertex colors
   float
      afLightLevels2 [] = { 0.5, 0.4, 0, 0.2 };

   oDraw.mIntLgtTexturedPolygon ( astPol, astTex, afLightLevels2, 4, oTx1, NULL );

   // show frame buffer on screen
   oS.mShow ( oFrameBuffer );

   getchar ();
}
