/* Test CDraw with texture mapping */



#include <stdio.h>

#include "../3dfc.h"



main ()
{
   // load palette and bitmap
   CMem
      oPal;
   CTexture
      oTx1;
   CFilePCX
      oFile ( "texture.pcx", oTx1, oPal );

   // define light table (need to draw any texture)
   CLightTable
      oLgT;
   oLgT.mCreate ( oPal, 1, 1, 1, 1 );

   // init graphics and program palette
   CScreen
      oS;
   oS.mCreate ( MODE_MCGA );
   oS.mSetPalette ( oPal );

   // define frame buffer
   CMem
      oFrameBuffer ( 320 * 200 );

   CDraw
      oDraw ( oLgT, 320, 200, oFrameBuffer );

   oDraw.mClear ( 0 );

   // define polygon and texture vertexes
   tagXY
      astPol [ 4 ],
      astTex [ 4 ];
   astPol [ 0 ].nX = 120;
   astPol [ 0 ].nY = 150;
   astPol [ 1 ].nX = 200;
   astPol [ 1 ].nY = 160;
   astPol [ 2 ].nX = 200;
   astPol [ 2 ].nY = 55;
   astPol [ 3 ].nX = 150;
   astPol [ 3 ].nY = 50;

   astTex [ 0 ].nX = 0;
   astTex [ 0 ].nY = 0;
   astTex [ 1 ].nX = 0;
   astTex [ 1 ].nY = oTx1.m_nHeight - 1;
   astTex [ 2 ].nX = oTx1.m_nWidth - 1;
   astTex [ 2 ].nY = oTx1.m_nHeight - 1;
   astTex [ 3 ].nX = oTx1.m_nWidth - 1;
   astTex [ 3 ].nY = 0;

   oDraw.mTexturedPolygon ( astPol, astTex, 4, oTx1, NULL, 0.5 );

   // show frame buffer on screen
   oS.mShow ( oFrameBuffer );

   getchar ();
}
