/* Test CDraw and CLightTable */



#include <stdio.h>

#include "../3dfc.h"



/* Return one key code
**********************************************************/
BYTE Key ()
{
   #ifdef TRG_LINUX
   return vga_getkey ();
   #endif

   #ifdef TRG_DJGPP
   return getch ();
   #endif
}



main ()
{
   // define light parameters
   DWORD
      dwNumLevels = 16;    // number of light levels
   float
      fR = 0,              // the light color (r,g,b components)
      fG = 0,
      fB = 0;
   printf ( "Before run this demo verify compiling flags in config.h,\n" );
   printf ( "lights must be enabled.\n" );
   printf ( "\nDemonstrate shaded polygons.\nUse how much light levels (recomended 16): " );
   scanf ( "%d", &dwNumLevels );
   printf ( "Light color information:\nHow much red   (between 0 and 1, eg: 1.0): " );
   scanf ( "%f", &fR );
   printf ( "How much green (between 0 and 1, eg: 1.0): " );
   scanf ( "%f", &fG );
   printf ( "How much blue  (between 0 and 1, eg: 1.0): " );
   scanf ( "%f", &fB );

   // load bitmap and palette
   printf ( "\nLoading texture and palette...\n" );
   CTexture
      oTx;
   CMem
      oPal;
   CFilePCX
      oFile ( "texture.pcx" , oTx, oPal );
   // program palette (for debug)
   /** ( oPal.m_payMem + 7 * 3 + 0 ) = 50;
   * ( oPal.m_payMem + 7 * 3 + 1 ) = 50;
   * ( oPal.m_payMem + 7 * 3 + 2 ) = 50;*/

   // define frame buffer
   printf ( "Creating frame buffer...\n" );
   CMem
      oFrameBuffer ( 320 * 200 );

   // define light table
   printf ( "Generating light table with %d levels...\n", dwNumLevels );
   CLightTable
      oLgT;
   oLgT.mCreate ( oPal, dwNumLevels, fR, fG, fB );

   // instructions
   printf ( "\nPress A to increase light;\n      Z to decrease light;\n      ESC to exit.\n\n" );
   printf ( "Type something and ENTER to continue.\n" );
   char
      szStr [ 100 ];
   scanf ( "%s", szStr );

   // init graphics and program palette
   CScreen
      oS;
   oS.mCreate ( MODE_MCGA );
   oS.mSetPalette ( oPal );

   // draw object
   CDraw
      oDraw ( oLgT, 320, 200, oFrameBuffer );
   oDraw.mClear ( 0 );

   // define polygon and texture vertexes
   tagXY
      astPol [ 4 ],
      astTex [ 4 ];
   astPol [ 0 ].nX = 130;
   astPol [ 0 ].nY = 150;
   astPol [ 1 ].nX = 200;
   astPol [ 1 ].nY = 180;
   astPol [ 2 ].nX = 210;
   astPol [ 2 ].nY = 55;
   astPol [ 3 ].nX = 150;
   astPol [ 3 ].nY = 30;

   astTex [ 0 ].nX = 0;
   astTex [ 0 ].nY = 0;
   astTex [ 1 ].nX = 0;
   astTex [ 1 ].nY = oTx.m_nHeight - 1;
   astTex [ 2 ].nX = oTx.m_nWidth - 1;
   astTex [ 2 ].nY = oTx.m_nHeight - 1;
   astTex [ 3 ].nX = oTx.m_nWidth - 1;
   astTex [ 3 ].nY = 0;

   // make interactions
   BOOL
      bEnd = FALSE;
   float
      fInc = (float) 1 / dwNumLevels,   // the light is defined with values
      fLight = fInc * dwNumLevels / 2;  // between 0 and 1
   while ( ! bEnd ) {

      oDraw.mTexturedPolygon ( astPol, astTex, 4, oTx, NULL, fLight );

      // show frame buffer on screen
      oS.mShow ( oFrameBuffer );

      //gotoxy ( 1, 1 );
      //printf ( "%f\n", fLight );

      switch ( Key () ) {

         case 'a':
         case 'A':
            if ( fLight < 1 )
               fLight += fInc;
            break;

         case 'z':
         case 'Z':
            if ( fLight > 0 )
               fLight -= fInc;
            break;

         case 27:
            bEnd = TRUE;
      }
   }
}
