/* Test CList */



#include <stdio.h>

#include "../3dfc.h"



// node derived from CNode, all CList nodes must derive from CNode
class CMyNode : public CNode {

public:

   CMyNode () {}
   CMyNode ( INT nValue )
   {
      m_nValue = nValue;
   }

   INT m_nValue;
};



main ()
{
   CList
      oL;

   CMyNode
      *poN1;

   // include nodes

   oL.mSetEnd ( new CMyNode ( 0 ) );
   oL.mSetEnd ( new CMyNode ( 1 ) );
   oL.mSetEnd ( new CMyNode ( 2 ) );
   oL.mSetEnd ( new CMyNode ( 3 ) );
   oL = new CMyNode ( 4 );
   oL = new CMyNode ( 5 );

   // optimize random access with indexes
   oL.mEnableDirectAccess ();

   // interaction method 1: access pointers
   // I unrecomend you use this method in your programms!!
   printf ( "\n1. " );
   poN1 = (CMyNode*) oL [ 0 ];
   while ( poN1 != NULL ) {

      printf ( "%d ", poN1->m_nValue );
      poN1 = (CMyNode*) poN1->m_poNext;
   }

   // interaction method 2: select next
   // The problem of this method is if the list is empty.
   printf ( "\n2. " );
   oL.mSelectStart ();
   do {

      printf ( "%d ", ( (CMyNode*) oL.mRetSelected ())->m_nValue );
   } while ( oL.mSelectNext () );

   // interaction method 3: test possible end of list with selection
   // Use this method in your programms. Test if list is empty before start.
   printf ( "\n3. " );
   oL.mSelectStart ();
   while ( oL.mRetExistSelection () ) {

      printf ( "%d ", ( (CMyNode*) oL.mRetSelected ())->m_nValue );
      oL.mSelectNext ();
   }

   // interaction method 4: indexed access
   // Good if you need random access.
   printf ( "\n4. " );
   for ( DWORD dwcCounter = 0; dwcCounter < oL.mRetNumNodes (); dwcCounter ++ )
      printf ( "%d ", ( (CMyNode*) oL.mRetNode ( dwcCounter ))->m_nValue );

   // number of nodes
   printf ( " total: %d\n", oL.mRetNumNodes () );

   // delete nodes
   oL.mRemoveAll ();
}
