/* Test CDraw */



#include <stdio.h>

#include "../3dfc.h"



main ( INT nNumArgs, char *szArgs [] )
{
   // verify parameters passed to aplication, if no parameters usage message
   if ( nNumArgs == 1 ) {
      printf ( "Draw an image loaded from a PCX file version 5.\n\nUse: showpcx file\n" );
      return 0;
   }

   // define file name
   CString
      oszFile ( szArgs [ 1 ] );

   // read bitmap
   CTexture
      oTx;
   CFilePCX
      oFile ( "texture.pcx", oTx, FALSE );

   // test if bitmap size is greater than 320 in X or 200 in Y
   if ( oTx.m_nWidth > 320 || oTx.m_nHeight > 200 ) {
      printf ( "Error, maximum image size: 320x200.\n" );
      return 0;
   }

   // load and program pal
   CMem
      oPal;
   oFile.mLoadPalette ( oszFile, oPal );

   // make a light table
   CLightTable
      oLgT ( oPal, 1, 1, 1, 1 );
   
   // draw bitmap on frame buffer
   CMem
      oFrameBuffer ( 320 * 200 );
   CDraw
      oDraw ( oLgT, 320, 200, oFrameBuffer );
   oDraw.mClear ( 0 );
   oDraw.mCopy ( 0, 0, oTx.m_nWidth, oTx.m_nHeight, (CMem&) oTx );

   // init graphics and set palette
   CScreen
      oS;
   oS.mCreate ( MODE_MCGA );
   oS.mSetPalette ( oPal );

   // show frame buffer on screen
   oS.mShow ( oFrameBuffer );

   getchar ();
}
