/* Teste de ASM no DJGPP */


#include<stdio.h>



main ()
{
   char
      ayOrigem [ 2 ] [ 3 ] = { { 65, 66, 67 },
                               { 68, 69, 70 } };
   char
      ayDestino [] = { 64, 64, 64, 64, 64, 0 };
   char
      *pyDest = ayDestino + 3;
   char
      *pyOrig = (char*) ayOrigem;

   
   // Copia um byte do array 2D apontado por pyOrig para local
   // apontado por pyDest.
   // X e Y estao em ponto fixo 16.16
   // Array pode ter qualquer largura (no caso 3 bytes).
   // endereco = array + Y * 3 + X


   printf ( "%s\n", ayDestino );
   
   
   // Equivalente em C:
   // pyDest = * ( pyOrig + TEX_RESX * ( ( nTexY >> 16 ) & TEX_MAXY ) + ( ( nTexX >> 16 ) & TEX_MAXX ) )
   /*
      movl  %2,       %%eax    <- X
      shrl  $16,      %%eax    <- converte para int normal (nao fixo)
      andl  $255,     %%eax    <- cuida para nao passar de 255
      
      movl  %3,       %%ebx    <- Y
      shrl  $16,      %%ebx    <- converte para int normal (nao fixo)
      andl  $255,     %%ebx    <- cuida para nao passar de 255
      
      imull $3,       %%ebx    <- posicao no array conforme largura
      addl  %%ebx,    %%eax    <- posicao no array linearmente
      addl  %1,       %%eax    <- soma endereco array
      movb  %%eax,    %0"      <- conteudo
   */

   __asm__ __volatile__ ("
      
      movl  %2,       %%eax
      shrl  $16,      %%eax
      andl  $255,     %%eax
      
      movl  %3,       %%ebx
      shrl  $16,      %%ebx
      andl  $255,     %%ebx
      
      imull $3,       %%ebx
      addl  %%ebx,    %%eax
      addl  %1,       %%eax
      movb  %%eax,    %0"
      
      : "=g" ( *pyDest )
      : "g" ( *pyOrig ), "g" ( 1 << 16 ), "g" ( 0 << 16 )
      : "eax", "ebx"
   );
   // parametros: destino, origem, X, Y


   printf ( "%s - novo %d\n", ayDestino, *pyDest );
}
