/* Teste de ASM no DJGPP */


#include<stdio.h>
#include<string.h>



main ()
{
   char
      ayOrigem [ 256 ] [ 256 ];
   
   memset ( (void*) ayOrigem, 0, 256 * 256 );
   ayOrigem [ 34 ] [ 70 ] = 65;   // y, x!!!

   printf ( "origem: %d\n", ayOrigem [ 34 ] [ 70 ] );
   
   char
      ayDestino [] = { 64, 64, 64, 64, 64, 0 };
   
   char
      *pyDest = ayDestino + 1;
   
   char
      *pyOrig = (char*) ayOrigem;

   
   // Copia um byte do array 2D apontado por pyOrig para local
   // apontado por pyDest.
   // X e Y estao em ponto fixo 16.16
   // Array pode ter qualquer largura (no caso 256 bytes).
   // endereco = array + Y * 256 + X


   printf ( "%s\n", ayDestino );
   
   
   // Equivalente em C:
   // pyDest = * ( pyOrig + 256 * ( ( nTexY >> 16 ) & 255 ) + ( ( nTexX >> 16 ) & 255 ) )

   // Versao mais otimizada nao implementada em ASM:
   // pyDest = * ( pyOrig + 256 * ( nTexY >> 16 ) + ( nTexX >> 16 ) )
   // os ANDs soh sao para seguranca

   // Versao ainda mais otimizada nao implementada em ASM tem:
   //   ( nTexY >> 8 ) & 0xFF00   ==   256 * ( nTexY >> 16 )


   __asm__ __volatile__ ("
      
      movl  %2,       %%esi   /* x */
      shrl  $16,      %%esi   /* fix   int */
      andl  $255,     %%esi   /* test for texture overflow */
      
      movl  %3,       %%eax   /* y */
      shrl  $16,      %%eax   /* fix   int */
      andl  $255,     %%eax   /* test for texture overflow */
      
      shll  $8,       %%eax   /* linearize   equal   mull 256 */
      
      addl  %%eax,    %%esi   /* offset in array */
      addl  %1,       %%esi   /* address in memory */
      
      movl  (%%esi),  %%eax   /* load texel */

      movb  %%eax,    %0"     /* store texel */
      
      : "=g" ( *pyDest )
      : "g" ( pyOrig ), "g" ( 70 << 16 ), "g" ( 34 << 16 )
      : "eax", "esi"
   );
   // parametros: destino, origem, X, Y

   // Tentar:
   // movl  (%%esi),  %%eax   /* load texel */
   //   --->
   //       movb  (%%esi),  %%ah   /* load texel */
   //       movb  %%ah,    %0"     /* store texel */

   printf ( "%s - novo %d\n", ayDestino, *pyDest );
}
