/* Teste de ASM no DJGPP */


#include<stdio.h>
#include<string.h>



main ()
{
   // Le um byte de um array 2D, o byte eh a usado como X na leitura
   // de um segundo array. Le o byte do segundo array (pyOrigem2) e
   // copia para local apontado por pyDest.
   // X1 e Y1 estao em ponto fixo 16.16
   //   Array origem 1 pode ter qualquer largura e altura.
   //   Array origem 2 pode ter qualquer largura e altura.
   //   Apenas eh necessario adaptar o codigo asm (menos para altura do
   //   array 2 que pode ser qualquer uma).

   // array 2D, elementos tem valores X2
   char
      ayOrigem [ 256 ] [ 256 ];
   memset ( (void*) ayOrigem, 0, 256 * 256 );
   ayOrigem [ 34 ] [ 70 ] = 10;   // y, x!!!

   // array de 16 linhas e 256 colunas, tem valores a serem lidos
   char
      ayOrigem2 [ 16 ] [ 256 ];   // 16 linhas e 256 colunas
   memset ( (void*) ayOrigem2, 0, 16 * 256 );
   ayOrigem2 [ 5 ] [ 10 ] = 71;   // y, x!!!

   // ponteiros para os arrays (se for direto no asm da problema de cast)
   char
      *pyOrig = (char*) ayOrigem,
      *pyOrig2 = (char*) ayOrigem2;

   printf ( "origem 1: %d\n", ayOrigem [ 34 ] [ 70 ] );
   printf ( "origem 2: %d\n", *( pyOrig2 + 10 + 5 * 256 ) );
   
   // destino para o valor lido
   char
      ayDestino [] = { 64, 64, 64, 64, 64, 0 };
   char
      *pyDest = ayDestino + 1;

   /* Equivalente em C:
   *pyDest = * ( pyOrig2 +

                 * ( pyOrig + ( ( Y >> 8 ) & 0xFF00 ) + ( X >> 16 ) ) +

                 ( ( Y2 >> 8 ) & 0xFF00 ) );
   */

   // Aqui foi usado uma simplificacao:
   //  256 * ( V >> 16 ) ==
   // ( V >> 16 ) << 16  ==
   // ( V >> 8 ) & 0xFF00          - mais rapido ?!

   /*
      movl  %2,       %%esi;     X na origem 1
      shrl  $16,      %%esi;     converte fix int (>>16)
                               
      movl  %3,       %%eax;     Y na origem 1
      shrl  $8,       %%eax;     converte fix int e multiplica
      andl  $65280,   %%eax;     (usa calculo simpliticado)
                              
      addl  %%eax,    %%esi;     offset no array
      addl  %1,       %%esi;     offset na memoria

      movl  %5,       %%eax;     le linha (Y2)
      shrl  $8,       %%eax;     converte fix int e multiplica
      andl  $65280,   %%eax;     (usa calculo simpliticado)
      addl  %4,       %%eax;     offset da linha na memoria

      xorl  %%ebx,    %%ebx;     zera coluna
      movb  (%%esi),  %%bl;      le coluna: X2
      addl  %%ebx,    %%eax;     offset do valor de origem 2

      movl  %%eax,    %%esi;     copia endereco de origem 2
      movb  (%%esi),  %%al;      le valor em origem 2
      movb  %%al,     %0;        poe no destino
   */

   printf ( "destino antes %s\n", ayDestino );

   __asm__ __volatile__ ("     
      movl  %2,       %%esi;
      shrl  $16,      %%esi;
                               
      movl  %3,       %%eax;
      shrl  $8,       %%eax;
      andl  $65280,   %%eax;
                              
      addl  %%eax,    %%esi;
      addl  %1,       %%esi;

      movl  %5,       %%eax;
      shrl  $8,       %%eax;
      andl  $65280,   %%eax;
      addl  %4,       %%eax;

      xorl  %%ebx,    %%ebx;
      movb  (%%esi),  %%bl; 
      addl  %%ebx,    %%eax;

      movl  %%eax,    %%esi;
      movb  (%%esi),  %%al;
      movb  %%al,     %0;"

      : "=g" ( *pyDest )
      : "g" ( pyOrig ), "g" ( 70 << 16 ), "g" ( 34 << 16 ), "g" ( pyOrig2 ), "g" ( 5 << 16 )
      : "eax", "esi", "bl"
   );
   // parametros:
   // destino, origem 1, X1, Y1, origem 2, Y2 (o X2 eh lido de origem 1)

   printf ( "%s - novo %d\n", ayDestino, *pyDest );
}
