/* Make Install utility - generate a self extractor pak file.

For instructions read docs/utils.txt */



#include "../../3dfc.h"

#include <dirent.h>



/* Write beginning
**********************************************************/
void WriteBegin ( CFile& oOut, CString& oszDirTree )
{
   oOut.mSetStr ( "/* This file is a self extractor source, generated by MKINS,\n" );
   oOut.mSetStr ( "   over the directory: " );
   oOut.mSetStr ( (char*) oszDirTree );
   oOut.mSetStr ( "\n" );
   oOut.mSetStr ( "\n" );
   oOut.mSetStr ( "   Compile with: gcc -o this_file_name.exe this_file_name.c\n" );
   oOut.mSetStr ( "*/\n" );
   oOut.mSetStr ( "\n" );
   oOut.mSetStr ( "\n" );
   oOut.mSetStr ( "\n" );
   oOut.mSetStr ( "#include <stdio.h>\n" );
   oOut.mSetStr ( "\n" );
   oOut.mSetStr ( "\n" );
   oOut.mSetStr ( "\n" );
   oOut.mSetStr ( "main ()\n" );
   oOut.mSetStr ( "{\n" );
   oOut.mSetStr ( "   // THE PACKED DATA\n" );
   oOut.mSetStr ( "   char\n" );
   oOut.mSetStr ( "      achData [ 200000 ];\n" );
}



/* Write end
**********************************************************/
void WriteEnd ( CFile& oOut )
{
   oOut.mSetStr ( "   // UNPACK CODE\n" );
   oOut.mSetStr ( "}\n" );
}



/* Write a string as a byte array: "ABC" -> 'A', 'B', 'C'
**********************************************************/
void WriteString ( CFile& oOut, DWORD &dwIndex, CString oszStr )
{
   // scan string
   DWORD
      dwLen = oszStr.mRetLength ();
   char
      szData [ 200 ];
   for ( DWORD dwS = 0; dwS < dwLen; dwS ++ ) {
      // write assign command
      sprintf ( szData, "   achData [ %03u ] = ", dwIndex );
      oOut.mSetStr ( szData );
      // one character
      char
         szWrite [ 4 ];
      szWrite [ 0 ] = 39;              // character open cote
      szWrite [ 1 ] = oszStr [ dwS ];  // character
      szWrite [ 2 ] = 39;              // character close cote
      szWrite [ 3 ] = 0;               // string end
      oOut.mSetStr ( szWrite );
      // write end command
      oOut.mSetStr ( ";\n" );
      // next index
      dwIndex ++;
   }

   // write string terminator
   sprintf ( szData, "   achData [ %03u ] = 0;\n", dwIndex );
   oOut.mSetStr ( szData );
   
   // next index
   dwIndex ++;
}



/* Write file data
**********************************************************/
void WriteFile ( CFile& oOut, DWORD &dwIndex, CString oszDirTree )
{
   printf ( "Adding file: %s\n", (char*) oszDirTree );
   
   // try open file
   CFile
      oIn;
   oIn.mOpen ( (char*) oszDirTree, "rb" );

   // write file name and size in data array
   // write file name
   oOut.mSetStr ( "   /* file name */\n" );
   CString
      oszName,   // remove path, only name and extension
      oszExt;
   oIn.mRetNameExt ( oszName, oszExt );
   CString
      oszJoin = oszName + oszExt;
   WriteString ( oOut, dwIndex, oszJoin );
   
   // write file size
   oOut.mSetStr ( "   /* file size */\n" );
   char
      szStr [ 200 ];
   DWORD
      dwSize = oIn.mRetSize ();
   sprintf ( szStr, "%u", dwSize );
   WriteString ( oOut, dwIndex, szStr );

   // write file contents
   oOut.mSetStr ( "   /* file */\n" );
   for ( DWORD dwcL = 0; dwcL < dwSize; dwcL ++ ) {
      
      // read byte
      char
         chByte;
      oIn.mRetMem ( 1, &chByte );
      
      // write
      char
         szStr [ 4 ];
      sprintf ( szStr, "   achData [ %03u ] = %03d;\n", dwIndex, chByte );
      oOut.mSetStr ( szStr );

      // next index
      dwIndex ++;
   }  
   oOut.mSetStr ( "\n" );
}



/* Write pack data
**********************************************************/
void WritePak ( CFile& oOut, CString oszDirTree )
{
   // the data array index
   DWORD
      dwIndex = 0;
   
   // try open directory
   DIR
      *pDir = opendir ( "(char*) oszDirTree" );
   // if can't, assume the parameter is a file name, store file
   if ( pDir == NULL )
      WriteFile ( oOut, dwIndex, oszDirTree );
   else {
      // if dir opened, read its contents
      //WriteDir ( CFile& oOut, pDir );
      //closedir ( pDir );
   }
}



main ( INT nNumArgs, char *szArgs [] )
{
   // verify command line options
   if ( nNumArgs < 3 ) {
      printf ( "Make Install - generate a C source for a self extractor pak file\n" );
      printf ( "\nUse: mkins c_pak_file directory_tree\n" );
      return 0;
   }
      
   // define directory tree to pak
   CString
      oszDirTree = szArgs [ 2 ];

   // try create the output file
   CString
      oszOut = szArgs [ 1 ];
   CFile
      oOut;
   if ( ! oOut.mOpen ( oszOut, "wt" ) ) {
      printf ( "Error creating file `%s'.\n", (char*) oszOut );
      return 0;
   }

   // write output file
   WriteBegin ( oOut, oszDirTree );
   WritePak ( oOut, oszDirTree );
   WriteEnd ( oOut );
   
   oOut.mClose ();
}
