/* Implement an object component.
Components compose an object feature: light source, mesh,
make some special task (like read the keyboard). */



#include "../defs.h"

#include "../mem.h"

#include "../string.h"

#include "../node.h"

#include "../list.h"

#include "../polygon.h"

#include "../nodepol.h"

#include "../nodeint.h"

#include "../map.h"

#include "../mesh.h"

#include "../sector.h"

#include "../nodesec.h"

#include "../math.h"

#include "../refsys.h"

#include "../camsys.h"

#include "../nodesec.h"

#include "../lighttab.h"

#include "../scenery.h"

#include "../object.h"

#include "../nodeobj.h"

#include "../nodecomp.h"

#include "comp.h"



/* constructor - init empty component
**********************************************************/
CComponent::CComponent ()
{
	m_poMyObj = NULL;
	m_dwType = TYPE_UNKNOWN;
}



/* constructor - init empty component
**********************************************************/
CComponent::CComponent ( CObject* poObj )
{
	m_poMyObj = NULL;
	m_dwType = TYPE_UNKNOWN;

   if ( ! mCreate ( poObj ) )
      ABORT ( MSG_ERROR_MEMORY_LOW, __FILE__, __LINE__ )
}



/* Set variable (make point to object).
return TRUE - ok / FALSE - error
**********************************************************/
BOOL CComponent::mCreate ( CObject* poObj )
{
	m_poMyObj = poObj;
	return TRUE;
}



/* Default component execution (make nothing)
**********************************************************/
void CComponent::mRun ( CNodeSector& oParentSec )
{
}
