CDraw::mTexturedPolygon (removed after version 0.1.0)
***********************************************************
   // define type of texture size (needed to draw horizontal line)
   BYTE
      yTypeSize;
   // if texture has size 64x64
   if ( oTx.m_nWidth == 64 && oTx.m_nHeight == 64 )
      yTypeSize = 0;
   else
      // if texture has size 256x256
      if ( oTx.m_nWidth == 256 && oTx.m_nHeight == 256 )
         yTypeSize = 1;
      else {
         // known size
         yTypeSize = 2;
         m_nTexWidth = oTx.m_nWidth;
         m_nTexHeight = oTx.m_nHeight;
      }

(removed after version 0.1.0) - line with multiple texture sizes
**********************************************************/
void CDraw::mHorizontalTexturedLine ( INT nXIni, INT nXEnd,
                                      tagXY& stTexIni,
                                      tagXY& stTexEnd,
                                      BYTE yTypeSize,
                                      tagInterval& stLimits,
                                      BYTE* pyTex, PTRVAL pLineAddress,
                                      DWORD dwLightLevel )
{
   // clip x values
   INT
      nFrXIni = nXIni,   // define left X value in frame buffer
      nFrXEnd = nXEnd;   // define right X value in frame buffer
   // verify start
   if ( nXIni < stLimits.nStart )
      nFrXIni = stLimits.nStart;
   // verify end
   if ( nXEnd > stLimits.nEnd )
      nFrXEnd = stLimits.nEnd;

   // verify if line has no lenght
   if ( nFrXEnd <= nFrXIni )
      return;

   INT
      // define where texture X and Y start
      nTexX = stTexIni.nX,
      nTexY = stTexIni.nY,
      // texture X and Y increase rates
      nTexXInc = ( stTexEnd.nX - stTexIni.nX ) / ( nXEnd - nXIni ),
      nTexYInc = ( stTexEnd.nY - stTexIni.nY ) / ( nXEnd - nXIni );

   // if X has been clipped
   if ( nXIni < stLimits.nStart ) {
      nTexX -= ( nXIni - stLimits.nStart ) * nTexXInc;
      nTexY -= ( nXIni - stLimits.nStart ) * nTexYInc;
   }

   // define start and end address in frame buffer
   BYTE
      *pyCurr = (BYTE*) pLineAddress + nFrXIni,   // current address
      *pyEnd = (BYTE*) pLineAddress + nFrXEnd;    // end address

   // REVIEW
   // select a line draw loop acording the texture size
   switch ( yTypeSize ) {

      case 0:   // 64x64
         do {

            // write pixel (& 63 perform % 63, >> 10 because nTexY is 64)
            // light it
            *pyCurr = * ( m_poLightTable->m_payLightTable +
                          pyTex [ ( ( nTexX >> 16 ) & 63 ) + ( ( nTexY >> 10 ) & 4032 ) ] *
                          m_poLightTable->m_dwNumLevels + dwLightLevel );
            // update texture coordenates
            nTexX += nTexXInc;
            nTexY += nTexYInc;
            // go to next pixel
            pyCurr ++;

         } while ( pyCurr <= pyEnd );  // while not found end of line
         break;

      case 1:   // 256x256
         do {

            // REVIEW
            //if ( pyCurr >= m_poFrBuff->m_payMem && pyCurr <= ( m_poFrBuff->m_payMem + m_nResX * m_nResY - 1 ) ) {
               // light it
               *pyCurr = * ( m_poLightTable->m_payLightTable +
                             pyTex [ ( ( nTexX >> 16 ) & 255 ) + ( ( nTexY >> 8 ) & 0xff00 ) ] *
                             m_poLightTable->m_dwNumLevels + dwLightLevel );
               // update texture coordenates
               nTexX += nTexXInc;
               nTexY += nTexYInc;
            //}
            //else
               //ABORT ("Escreveu fora do frame buffer!\n",__FILE__,__LINE__)
            // go to next pixel
            pyCurr ++;

         } while ( pyCurr <= pyEnd );  // while not found end of line
         break;

      default:   // ?x?
         do {

            // light it
            *pyCurr = * ( m_poLightTable->m_payLightTable +
                          pyTex [ ( ( nTexX >> 16 ) % m_nTexWidth ) + ( ( nTexY >> 16 ) % m_nTexHeight ) * m_nTexWidth ] *
                          m_poLightTable->m_dwNumLevels + dwLightLevel );
            // update texture coordenates
            nTexX += nTexXInc;
            nTexY += nTexYInc;
            // go to next pixel
            pyCurr ++;

         } while ( pyCurr <= pyEnd );  // while not found end of line
         break;
   }
}
