Fix point 16.16
***********************************************************
refsys.h:
   
   // reference system base in fix point 16.16
   tagXYZ m_stFixI;  // the vetor I of reference system base (fix point)
   tagXYZ m_stFixJ;  // the vetor J of reference system base (fix point)
   tagXYZ m_stFixK;  // the vetor K of reference system base (fix point)
   void mComputeFixPointBase ();

refsys.cc:

   /* Transform floating point base to fix point 16.16.
   Call after change floating point base.
   **********************************************************/
   void CReferenceSystem::mComputeFixPointBase ()
   {
      m_stFixI.nX = (INT) ( m_stI.fX * 65536 );
      m_stFixI.nY = (INT) ( m_stI.fY * 65536 );
      m_stFixI.nZ = (INT) ( m_stI.fZ * 65536 );
      m_stFixJ.nX = (INT) ( m_stJ.fX * 65536 );
      m_stFixJ.nY = (INT) ( m_stJ.fY * 65536 );
      m_stFixJ.nZ = (INT) ( m_stJ.fZ * 65536 );
      m_stFixK.nX = (INT) ( m_stK.fX * 65536 );
      m_stFixK.nY = (INT) ( m_stK.fY * 65536 );
      m_stFixK.nZ = (INT) ( m_stK.fZ * 65536 );
   }

math.h:

   INT* m_panSin;       // sin lockup table (fix point 16.16)
   INT* m_panCos;       // cos lockup table (fix point 16.16)

math.cc:

   m_panSin = m_panCos = NULL;

   alocate:
      if ( m_panSin == NULL ) {
         m_panSin = new INT [ ROUND ];
         if ( m_panSin == NULL )
            return FALSE;
      }
      if ( m_panCos == NULL ) {
         m_panCos = new INT [ ROUND ];
         if ( m_panCos == NULL )
            return FALSE;
      }

      // fix point 16.16
      m_panSin [ ncD ] = (INT) ( sin ( ncD * PI / ROUND * 2 ) * 65536 );
      m_panCos [ ncD ] = (INT) ( cos ( ncD * PI / ROUND * 2 ) * 65536 );

   desalocate:
      if ( m_panSin != NULL ) {
         delete m_panSin;
         m_panSin = NULL;
      }
      if ( m_panCos != NULL ) {
         delete m_panCos;
         m_panCos = NULL;
      }

