

/* Set the object dwCameraID as the current camera.
Invert the vector K component Z.
return TRUE - ok / FALSE - error
**********************************************************/
BOOL CScenery::mSetCurrentCamera ( DWORD dwCameraID )
{
   // invert some camera components of the last camera, if exist
   if ( m_poCamera != NULL ) {
      CCameraSystem
         *poCamSys = (CCameraSystem*) ( (CComponentCameraSystem*) m_poCamera->mRetComponent ( SLOT_REFSYS ) )->m_paData;
      poCamSys->mInvertCamera ();
      m_poCamera->mDestroyComponent ( SLOT_REFSYS_KB_CTRL, 0, 0 );
   }
   
   // update camera
   // search for object
   CNodeObject
      *poNewCamera = (CNodeObject*) m_oRoot.mSearchObject ( dwCameraID );
   // verify if object not found
   if ( poNewCamera == NULL ) {
      printf ( MSG_ERROR_CAMERA_OBJECTID_NOT_FOUND, dwCameraID );
      printf ( MSG_DEFAULT_ABORT_INFO, __FILE__, __LINE__ );
      return FALSE;
   }
   CCameraSystem
      *poNewCamSys = (CCameraSystem*) ( (CComponentCameraSystem*) poNewCamera->mRetComponent ( SLOT_REFSYS ) )->m_paData;
   poNewCamSys->mInvertCamera ();
   poNewCamera->mCreateComponent ( SLOT_REFSYS_KB_CTRL, TYPE_CAMERA, 0, 0 );

   m_poCamera = poNewCamera;

   return TRUE;
}
