/* Declare a CMesh component. */



#include "../defs.h"

#include "../node.h"

#include "../list.h"

#include "../map.h"

#include "../polygon.h"

#include "../nodepol.h"

#include "../nodeint.h"

#include "../nodeflo.h"

#include "../nodexyz.h"

#include "../math.h"

#include "../mesh.h"

#include "../refsys.h"

#include "../camsys.h"

#include "nodecomp.h"

#include "comesh.h"



/* contructor - init with default component type
**********************************************************/
CComponentMesh::CComponentMesh ()
{
   m_dwMyTypeID = TYPE_MESH;
}



/* destructor - desalocate data
**********************************************************/
CComponentMesh::~CComponentMesh ()
{
}



/* Activate: do something acording the parameter pData1.
pData1 - if 0 - does nothing
            1 - signals data addition in mesh
            2 - signals end of data addition in mesh
pData2 - if pData1 is 0 - not used
                      1 - not used
                      2 - not used
pData3 - not used
return - if pData1 is 0 - TRUE - ok / FALSE - error
                      1 - TRUE - ok / FALSE - error
                      2 - value 0
**********************************************************/
PTRVAL CComponentMesh::mActivate ( PTRVAL pData1, PTRVAL pData2, PTRVAL pData3 )
{
   pData2 = pData2;        // to avoid GCC warnings
   pData3 = pData3;

   // make action acording pData1
   switch ( pData1 ) {

      case 1:
         return (PTRVAL) m_oMesh.mBeginAddMesh ();
         break;

      case 2:
         return (PTRVAL) m_oMesh.mEndAddMesh ();
         break;

      default:
         return 0;
         break;
   }

   return 0;
}
