/* Debug facilitys.
Usefull to verify conditions or provide some control in crazy codes.

WARNING WITH ; ON END OF MACROS! YOU CAN HAVE CONFUSION IN EXPANSIONS! */



// verify if has been declared, if no do it
#ifndef __3DFC_DEBUG_H__



// signals file inclusion
#define __3DFC_DEBUG_H__



// verify if files header needed have been already included, if no include
#ifndef __dj_include_stdio_h_
   #include <stdio.h>
#endif

#ifndef __dj_include_stdlib_h_
   #include <stdlib.h>
#endif

#ifndef __dj_include_conio_h_
   #include <conio.h>
#endif

#ifndef __3DFC_KEYBOARD_H__
   #include "djgpp\keyboard.h"
#endif

#ifndef __3DFC_DEFS_H__
   #include "defs.h"
#endif



// wait key press to continue
#define DBG_WAIT \
{ \
   CKeyboard \
      oKb; \
   oKb.mWaitAllPress (); \
}



// test condition, if false show message and wait a key press
#define DBG_TEST(C) \
{ \
   if ( ! ( C ) ) { \
      printf ( "CONDITION FAULT: %s, file: %s, line: %d.\n", #C, __FILE__, __LINE__ ); \
   CKeyboard \
      oKb; \
   oKb.mWaitAllPress (); \
   } \
}



// test condition, if not satisfy wait for an action, usefull in loops
#define DBG_TEST_OP(C) \
{ \
   if ( ! ( C ) ) { \
      printf ( "CONDITION FAULT: %s, file: %s, line: %d.\n", #C, __FILE__, __LINE__ ); \
      printf ( "[i]gnore; '[b]reak'; '[e]xit'; '[c]ontinue'\n" ); \
      char \
         chKey = 0; \
      while ( chKey != K_I && chKey != K_B && \
              chKey != K_E && chKey != K_C ) { \
         CKeyboard \
            oKb; \
         chKey = oKb.mGetKeys (); \
      } \
      if ( chKey == K_I ) \
         ;                   \
      if ( chKey == K_B )   \
         break;                \
      if ( chKey == K_E )     \
         ABORT ( MSG_USERABORT, __FILE__, __LINE__ );             \
      if ( chKey == K_C )       \
         continue;                 \
   } \
}



// declare and init pass-counter variable (see DBG_TEST_PASS)
#define DBG_DECLARE_PASS(V) INT (V) = 0;



// set a value to pass-counter variable (see DBG_TEST_PASS)
#define DBG_INIT_PASS(V,X) (V) = X;



// if execution pass to this macro more than L times do special action
#define DBG_TEST_PASS(V,L) \
{ \
   if ( V > L ) { \
      printf ( "LIMIT: %s > %s, file: %s, line: %d.\n", #V, #L, __FILE__, __LINE__ ); \
      printf ( "[i]gnore; [r]eset; '[b]reak'; '[e]xit'; '[c]ontinue'\n" ); \
      char \
         chKey = 0; \
      while ( chKey != K_I && chKey != K_B && \
              chKey != K_E && chKey != K_C && chKey != K_R ) { \
         CKeyboard \
            oKb; \
         chKey = oKb.mWaitAllPress (); \
      } \
      if ( chKey == K_I ) \
         ;                   \
      if ( chKey == K_R ) \
         V = 0;              \
      if ( chKey == K_B )   \
         break;                \
      if ( chKey == K_E )     \
         exit ( 1 );             \
      if ( chKey == K_C )       \
         continue;                 \
   } \
   else    \
      V ++; \
}



// positiones text cursor up-right screen corner
#define DBG_INIT_CURSOR \
{ \
   gotoxy ( 1, 1 ); \
}



// positiones text cursor in beginning of a specific line L
#define DBG_POS_LINE(L) \
{ \
   gotoxy ( 1, L ); \
}



// show message M
#define DBG_SHOW(M) \
{ \
   printf ( M ); \
}



// show message and the value of an int variable, no line feed
#define DBG_SHOW_INT_NL(M,V) \
{ \
   printf ( M ); \
   printf (" ( %d )", ( V ) ); \
}



// show message and the value of an int variable with line feed
#define DBG_SHOW_INT_LF(M,V) \
{ \
   printf ( M ); \
   printf (" ( %d )\n", ( V ) ); \
}



// if test true: show message V and the value of an int variable, line feed
#define DBG_SHOW_INT_IF(V,C) \
{ \
   if ( C ) \
      printf (" %s: %d \n", ( #C ), ( V ) ); \
}



// show value of a string V with line feed
#define DBG_SHOW_STR(V) \
{ \
   printf (" ( %s )\n", ( V ) ); \
}



// show value of an int V and wait a key press, with line feed
#define DBG_SHOW_INT_WAIT(V) \
{ \
   printf (" ( %d )\n", ( V ) ); \
   CKeyboard \
      oKb; \
   oKb.mGetKeys (); \
}



// show value of a string V and wait a key press, with line feed
#define DBG_SHOW_STR_WAIT(V) \
{ \
   printf (" ( %s )\n", ( V ) ); \
   CKeyboard \
      oKb; \
   oKb.mWaitAllPress (); \
}



// if a specific key T is pressed execute return R
#define DBG_RETURN(T,R) \
{                        \
   CKeyboard \
      oKb; \
   if ( oKb.mWaitKeyPress ( T ) )\
      return R;              \
}



// show line number where macro expands, good to verify execution path
#define DBG_PASS printf ( " EXECUTED LINE %d\n", __LINE__ )



// end declarations
#endif
