/* Declare engine.cc */



// verify if has been declared, if no do it
#ifndef __3DFC_ENGINE_H__



// signals file inclusion
#define __3DFC_ENGINE_H__



class CEngine {

public:

   CEngine ();
   CEngine ( CScenery &oScen, INT nResX, INT nResY, CMem& oFrBuff );
   ~CEngine ();

private:

   CScenery* m_poScen;      // scenery data, used in collision detection

   CRender m_oRender;       // render engine (make scenery images)

   #ifdef TRG_DJGPP
   CKeyboard m_oKb;         // keyboard control (is member to not construct)
   #endif

public:

   // for socket communication
   struct tagSocketInfo {
      char
         chSocketUse;     // flag: s - server / c - client / n - none
      CString
         oszIP;           // the IP address
      DWORD               
         dwPort;          // the port
      BOOL
         bConnected;      // TRUE - have connection / FALSE not now
      CSocket
         oCliSoc;         // client for communication between 2 processes
      CServerSocket
         oSrvSoc;         // server for communication between 2 processes
      // REVIEW por local
      CCameraSystem
         oSocCam;         // the camera to be sended/received
   } m_stSocketInfo;

   BOOL mCreate ( CScenery& oScen, INT nResX, INT nResY, CMem& oFrBuff );
   void mDestroy ();
   BOOL mRun ();
   void mMoveInstance ( CNodeObject& oObj, DWORD dwObjID,
                        CNodeSector& oParentSec,
                        DWORD dwDestinObjID, DWORD dwDestinSecID );
   void mDetectCollision ( CNodeObject& oObj, DWORD dwObjID,
                           CNodeSector& oParentSec, tagfXYZ& stDirection );
};



// end declarations
#endif
