/* Declare filepcx.cc */



// verify if has been declared, if no do it
#ifndef __3DFC_FILEPCX_H__



// signals file inclusion
#define __3DFC_FILEPCX_H__



class CFilePCX : CFile {

public:

   CFilePCX ();
   CFilePCX ( CString oszFile, CMem& oPal );
   CFilePCX ( CString oszFile, CTexture& oTx, BOOL bScale = TRUE );
   CFilePCX ( CString oszFile, CTexture& oTx, CMem& oPal, BOOL bScale = TRUE );

protected:

   // PCX header (128 bytes)
   struct tagHeaderPCX {
                          // byte  description
      BYTE yMan;          // 0   Manufacturer     10 = ZSoft
      BYTE yVer;          // 1   Version
      BYTE yEnc;          // 2   Encoding
      BYTE yBpP;          // 3   Bits Per Pixel
      UINT16 uXMin;       // 4   XMin
      UINT16 uYMin;       // 6   Ymin
      UINT16 uXMax;       // 8   XMax
      UINT16 uYMax;       // 10  YMax
      UINT16 uHRes;       // 12  Horizontal Resolution - disable
      UINT16 uVRes;       // 14  Verticle Resolution   - disable
      BYTE ayPal [ 48 ];  // 16  Color pallette setting
      BYTE yRes;          // 64  Reserved
      BYTE yCPl;          // 65  Number of color planes
      UINT16 uBLi;        // 66  Bytes per line
      UINT16 uTCo;        // 68  1 = Color    2 = Grayscale
      BYTE ayNone [ 58 ]; // 70  Blank
   };

public:

   BOOL mLoadPalette ( CString oszFile, CMem& oPal );
   BOOL mLoadTexture ( CString oszFile, CTexture& oTx, BOOL bScale = TRUE );
   BOOL mLoad ( CString oszFile, CTexture& oTx, CMem& oPal, BOOL bScale = TRUE );
};



// end declarations
#endif
