/* Implement a heap. Heap is a structure where the fisrt elements that
come in are the first that come out.

TIPS:
- the elements of heap must be derived from CNode
- this class is derived for CList. See CList for more info.
*/



#include "defs.h"

#include "node.h"

#include "list.h"

#include "heap.h"



/* Insert an element in heap
**********************************************************/
void CHeap::mHeapIn ( CNode* poNode )
{
   mSetStart ( poNode );
}



/* Return a pointer to first element and remove it from heap.
Caution: the returned element is not desalocated when removed.
**********************************************************/
CNode* CHeap::mHeapOut ()
{
   CNode
   	*poNode = m_poStart;

	// if list is not empty
	if ( m_poStart != NULL ) {

		// verify if list have only one node
		if ( m_poStart == m_poEnd )
			m_poStart = m_poEnd = m_poSelected = NULL;
		else {

         // verify if be selected the first node, if yes select next
         if ( m_poSelected == m_poStart )
         	m_poSelected = m_poSelected->m_poNext;

			// the new start node will be the next node
			m_poStart = m_poStart->m_poNext;
			m_poStart->m_poPrevious = NULL;
		}

		m_dwNumNodes --;
	}

   return poNode;
}
