/* Declare xwinapp.cc */



// verify if has been declared, if no do it
#ifndef __3DFC_XWINAPP_H__



// signals file inclusion
#define __3DFC_XWINAPP_H__



// resolution in graphics mode
#define RESX 320
#define RESY 200

// bits per pixel
#define BPP 8



class CXWindowApp {

public:

   CXWindowApp ();
   ~CXWindowApp ();

public:

   // X app data
   Display*     m_pstDisplay;
   XtAppContext m_stApContext;
   Widget       m_stTopLevel;
   Widget       m_stShell;
   Widget       m_stBox;

   // window data
   INT m_nScreenNum;
   INT m_nDpyWidth;
   INT m_nDpyHeight;
   Window   m_stWindow;
   XImage*  m_pXImg;
   GC       m_stGC;
   BYTE*    m_pVid;

   #ifdef DO_SHM
   static m_XShmSegmentInfo m_stShmi;
   XImage m_stShmImg;
   #endif

   // the palette
   Colormap m_stColorMap;

public:

   void mCreate ( INT nArgc, char* pszArgv [] );
   void mDestroy ();
   void mWritePal ( CMem& oMem );
   void mShow ( CMem& oMem );
   void mMakeLoop ();
};



// end declarations
#endif
