/* Declare list.cc */



// verify if has been declared, if no do it
#ifndef __3DFC_LIST_H__



// signals file inclusion
#define __3DFC_LIST_H__



class CList {

public:

   CList ();
   CList ( CList& oList );
   ~CList ();

protected:

   CNode* m_poStart;         // first node
   CNode* m_poEnd;           // last node
   CNode* m_poSelected;      // node selected for access
   DWORD m_dwNumNodes;       // number of nodes in list

public:

   CNode* * m_papoDirectAccess; // array of pointers to nodes, for fast access

   // functions for remove nodes
   void mRemoveAll ();
   CNode* mRemoveStart ( BOOL bDelete = FALSE );
   CNode* mRemoveEnd ( BOOL bDelete = FALSE );
   CNode* mRemoveSelected ( BOOL bDelete = FALSE );
   CNode* mRemoveNode ( DWORD dwIndex, BOOL bDelete = FALSE );

   // functions for insert nodes
   void mSetStart ( CNode* poNode );
   void mSetEnd ( CNode* poNode );
   void mSetSelected ( CNode* poNode );
   void mSetNode ( DWORD dwIndex, CNode* poNodeIns );

   // functions for access nodes
   CNode* mRetStart ();
   CNode* mRetEnd ();
   CNode* mRetSelected ();
   CNode* mRetNode ( DWORD dwIndex );

   // functions for define the selected node
   void mSelectStart ();
   void mSelectEnd ();
   BOOL mSelectNode ( DWORD dwIndex );
   BOOL mSelectNext ( DWORD dwOffset = 1 );
   BOOL mSelectPrevious ( DWORD dwOffset = 1 );
   BOOL mSelectOffset ( INT nOffset );
   BOOL mRetExistSelection ();

   // general purpose functions
   DWORD mRetNumNodes ();
   void mSetObj ( CList& oList );
   void mLinkExtremes ();
   void mUnlinkExtremes ();
   BOOL mEnableDirectAccess ();
   void mDisableDirectAccess ();

   // operators
   CNode* operator [] ( DWORD dwIndex );
   void operator = ( CNode* poNode );
   void operator = ( CList& oList );
};



// end declarations
#endif
