/* Declare math.cc */



// verify if has been declared, if no do it
#ifndef __3DFC_MATH_H__



// signals file inclusion
#define __3DFC_MATH_H__



class CMath {

public:

   CMath ( BOOL bBuildTrigTables = FALSE );
   ~CMath ();

public:

   float* m_pafSin;     // sin lockup table (floating point)
   float* m_pafCos;     // cos lockup table (floating point)

   BOOL mCreate ( BOOL bBuildTrigTables = FALSE );
   void mDestroy ();

   // basic math functions
   void mSort ( float &fA, float fB, float fC );

   // basic vector math
   void mSubVector ( tagfXYZ& stA, tagfXYZ& stB, tagfXYZ& stAnswer );
   void mNormalize ( tagfXYZ& stVector );
   float mDotProduct ( tagfXYZ& stVector1, tagfXYZ& stVector2 );
   void mCrossProduct ( tagfXYZ& stVector1, tagfXYZ& stVector2, tagfXYZ& stAnswer );
   float mRetMaximalDistance ( tagfXYZ& stA, tagfXYZ& stB );
   
   // polys and plans
   BOOL mPointInsidePoly ( tagfXYZ& stPoint, CNodePolygon *poPol, CList& oVertexes );
   void mDefinePolyPlanEquation ( CList& oVertexes, CNodePolygon* poPol );
   float mDistancePointPlan ( tagfXYZ& stPoint, tagfXYZ& stPlanNormal, float fPlanD );

   // transformations
   void mRotate ( BYTE yAX, BYTE yAY, BYTE yAZ, float& fX, float& fY, float& fZ );

   // reference system set
   void mSetViewBase ( tagfXYZ& stDirection, CReferenceSystem& oRefSys );
};



// end declarations
#endif
