/* Declare mesh.cc */



// verify if has been declared, if no do it
#ifndef __3DFC_MESH_H__



// signals file inclusion
#define __3DFC_MESH_H__



class CMesh {

public:

   CMesh ();
   ~CMesh ();

private:

   CMath m_oMath;           // for collision detection

public:

   // mesh data
   CList m_oPolygons;    // polygon definition: index of vertexes, start in 0 (CNodePolygon)
   CList m_oVertexes;    // vertexes of mesh in space (nodes of CNodeXYZ)
   CList m_oVertLight;   // light level for each vertex (CNodeLightInfo)

   // mesh data manipulation
   BOOL mBeginAddMesh ();
   BOOL mEndAddMesh ();
   void mDestroy ();
   void mAppendObj ( CMesh& oSrc );

   // mesh data addition and configuration
   BOOL mAddPolygon ( CList& oIndexes, DWORD dwLightID, float fLight );
   BOOL mAddPolygon ( CNodePolygon* poSrc );
   BOOL mAddVertex ( float fX, float fY, float fZ, float fScale = 1, float fNormLightLevel = DEFAULT_LIGHT_LEVEL );
   BOOL mSetDataValues ( INT nTypeID, float* pafData, DWORD dwNdxPol1, DWORD dwNdxPol2 );
   void mSetPortalPointers ( CMap* poSectors );

   // mesh use
   CNodePolygon* mDetectCollision ( tagfXYZ& stPoint,
                                    float fRadius,
                                    BYTE& yReturnCode );
};



// end declarations
#endif
