/* Declare neuron.cc */



// verify if has been declared, if no do it
#ifndef __3DFC_NEURON_H__



// signals file inclusion
#define __3DFC_NEURON_H__



class CNeuron {

public:

   CNeuron ();
   ~CNeuron ();

   float m_fNet;    // the net value computed in propagation

public:

   CNodeList m_oX;  // link to neurons in previous layer, is the input
   CList m_oW;      // neuron weights for inputs (list of CNodeFloat)

   BOOL mCreate ( CNodeList& oPreviousInput );
   BOOL mCreateWeights ( DWORD dwNumWeights );
   void mDestroy ();
   BOOL mSave ( CFile& oFile );
   BOOL mLoad ( CFile& oFile );
   float mRetPropagationValue ();
   float mRetAdaptationValue ();
   void mPropagate ( CList& oInput );
   void mPropagate ();
   void mAdapt ( float fRate, float fDelta, CList m_oSum );
   void mAdaptLast ( float fRate, float fDelta, CList oInput );
};



// end declarations
#endif
