/* Declare object.cc */



// verify if has been declared, if no do it
#ifndef __3DFC_OBJECT_H__



// signals file inclusion
#define __3DFC_OBJECT_H__



class CObject {

public:

   CObject ();
   ~CObject ();

private:

public:

   // object data
   CMap m_oComponents;      // components (CNodeComponent)
                            // possible are: lights, mesh,
                            // event handlers,...

   CScenery* m_poScen;      // scenery
   CNodeSector* m_poMySec;  // the sector where the object is inside 
   DWORD m_dwMyID;          // this object ID

   // object manipulation
   void mCreate ( DWORD dwMyID, CScenery* poScen, CNodeSector* poMySec );
   void mDestroy ();
   void mAppendObj ( CObject &oSrc, BOOL bInitAll );
   
   // components management
   PTRVAL mCreateComponent ( DWORD dwSlotID, DWORD dwTypeID, PTRVAL pData1, PTRVAL pData2, PTRVAL pData3 );
   PTRVAL mActivateComponent ( DWORD dwSlotID, PTRVAL pData1, PTRVAL pData2, PTRVAL pData3 );
   PTRVAL mDestroyComponent ( DWORD dwSlotID, PTRVAL pData1, PTRVAL pData2, PTRVAL pData3 );
   CNodeComponent* mRetComponent ( DWORD dwSlotID );
};



// end declarations
#endif
