/* Declare refsys.cc */



// verify if has been declared, if no do it
#ifndef __3DFC_REFSYS_H__



// signals file inclusion
#define __3DFC_REFSYS_H__



class CReferenceSystem {

public:

   CReferenceSystem ( BOOL bBuildTrigTables = FALSE );
   ~CReferenceSystem ();

public:

   CMath m_oM;       // have the math functions for rotation, ...

   // reference system base in floating point
   tagfXYZ m_stI;    // the vetor I of reference system base
   tagfXYZ m_stJ;    // the vetor J of reference system base
   tagfXYZ m_stK;    // the vetor K of reference system base
   // reference system origin
   tagfXYZ m_stPos;  // the position of SR in space

   void mCreate ( BOOL bBuildTrigTables );
   void mDestroy ();
   void mResetPos ();
   void mResetBase ();
   void mSetObj ( CReferenceSystem& oCS );
   void operator = ( CReferenceSystem& oCS );

   // transformation
   void mTransform ( CReferenceSystem& oC );
   void mApplyBase ( tagfXYZ& stPoint );
   void mRotateTransBase ( BYTE yAX, BYTE yAY, BYTE yAZ );
   void mRotateBase      ( BYTE yAX, BYTE yAY, BYTE yAZ );
};



// end declarations
#endif
