/* Declare render.cc */



// verify if has been declared, if no do it
#ifndef __3DFC_RENDER_H__



// signals file inclusion
#define __3DFC_RENDER_H__



class CRender {

public:

   CRender ();
   CRender ( CScenery &oScen, INT nResX, INT nResY, CMem& oFrBuff );
   ~CRender ();

private:

   // objects
   CScenery* m_poScen;        // scenery data, what draw
   CDraw m_oDraw;             // draw polys with texture mapping,...
   
   // general data
   CList m_oCamVert;          // temp to vert in camera system (CNodeXYZ)
   CList m_oPrjVert;          // temp to projected vertexes (CNodeXY)
   
   // the transformed poly (projected)
   tagXY* m_pastPolVertexCoords; // store x, y coords for projected vertexes
   #ifdef COMP_RENDER_INTERPOLATED_LIGHT
   float* m_pafPolVertexLights;  // store light level for projected vertexes
   #endif
   DWORD m_dwMaxVertArray;    // number of vertexes in array
   
   // new poly, clipped (if is the case)
   tagXY* m_pastPolZClipCoords; // x, y coords for projected and Z clip poly
   tagXY* m_pastPolZClipTex;    // x, y coord for texture vertexes clipped
   #ifdef COMP_RENDER_INTERPOLATED_LIGHT
   float* m_pafPolZClipLight;   // light level for vertexes
   #endif
   DWORD m_dwMaxZClipArray;     // number of vertexes in Z clipped poly array
   
   // texture coords
   tagXY m_astTexVertexes3 [ 3 ]; // texture coords for polys with 3 vertexes
   tagXY m_astTexVertexes4 [ 4 ]; // texture coords for polys with 4 vertexes
   tagXY m_astTexVertexes5 [ 5 ]; // texture coords for polys with 5 vertexes
   tagXY m_astTexVertexes6 [ 6 ]; // texture coords for polys with 6 vertexes
   tagXY m_astTexVertexes7 [ 7 ]; // texture coords for polys with 7 vertexes
   tagXY m_astTexVertexes8 [ 8 ]; // texture coords for polys with 8 vertexes

   // transformation
   void mApplyCamera ( CCameraSystem *poCamSys, CList& oSrc );
   void mAjust ( CCameraSystem *poCamSys );
   
   // rendering
   void mRenderSector ( CNodeSector* poSector, CCameraSystem *poCamSys,
                        BYTE yLevel, tagInterval* pastClipEdgeBuffer,
                        tagRectangle& stClipBox );
   void mRenderMesh ( CMesh& oMesh, CCameraSystem *poCamSys,
                      tagInterval* pastClipEdgeBuffer,
                      tagRectangle& stClipBox, BYTE yLevel );

   // pipeline misc functions (called for mesh rendering)
   BOOL mDefinePolygonData ( CNodePolygon *poPol, CList &oLights,
                                tagRectangle& stClipBox,
                                DWORD &dwBehind );
   BOOL mPassBackFaceCulling ();
   void mGetPolyTextureData ( CNodePolygon *poPol,
                              CTexture **ppoTx,
                              tagXY **ppastTexVertexes );
   DWORD mMakeZNearPlaneClip ( CNodePolygon* poPol,
                               tagXY *pastTexVertexes,
                               CCameraSystem *poCamSys,
                               tagInterval* pastClipEdgeBuffer,
                               tagRectangle& stClipBox );

public:

   BOOL mCreate ( CScenery& oScen, INT nResX, INT nResY, CMem& oFrBuff );
   void mDestroy ();
   void mRenderFrame ( CNodeObject* poCamera );
};



// end declarations
#endif
