/* Box Build - construct a box from the given user parameters and save
it on a TXE file.
To compile execute make utbb, at 3DFC root directory. */



#include "../../3dfc.h"



// global vars

// output file name
CString oszOUT ( 100 );

// first vertex
float fX = 0, fY = 0, fZ = 0;

// dimension
float fDIMX = 800, fDIMY = 800, fDIMZ = 800;

// steps between vertexes
float fSTEPX = 200, fSTEPY = 200, fSTEPZ = 200;

// breaks
// vertexes
INT nBREAKVERT = 5;
// polygons
INT nBREAKPOLY = 4;

// number of vertexes per poly (3 or 4)
INT
   nNUMVERTPOLY_LEFT = 4,
   nNUMVERTPOLY_RIGHT = 4,
   nNUMVERTPOLY_FRONT = 4,
   nNUMVERTPOLY_BACK = 4,
   nNUMVERTPOLY_TOP = 4,
   nNUMVERTPOLY_BOTTOM = 4;

// sort poly vertexes in what order (1-anti, 0-clockwise)
INT nUseAntiClockWiseOrder = 1;

// start indexes
INT
   nSTARTVERTINDEX = 0,
   nSTARTPOLYINDEX = 0;

// defines
#define STR_OUT_VERTEXES_BEGIN "Vertexes {"
#define STR_OUT_VERTEXES_END "}"
#define STR_OUT_POLYGONS_BEGIN "Polygons {"
#define STR_OUT_POLYGONS_END "}"
// write a polygon strip
#define WRITE_TO_DISK(NUMBER_VERTEXES) \
   if ( ( NUMBER_VERTEXES ) == 3 ) { \
      if ( nUseAntiClockWiseOrder )   \
         sprintf ( (char*) oszVal, "   %03d %03d %03d ;     /* %d */\n", nV1 + nSTARTVERTINDEX, nV2 + nSTARTVERTINDEX, nV3 + nSTARTVERTINDEX, nPolyNdx ); \
      else                                                                                           \
         sprintf ( (char*) oszVal, "   %03d %03d %03d ;     /* %d */\n", nV3 + nSTARTVERTINDEX, nV2 + nSTARTVERTINDEX, nV1 + nSTARTVERTINDEX, nPolyNdx );   \
      oOut.mSetStr ( (char*) oszVal );                                                                 \
      nPolyNdx ++;                                                                                      \
      if ( nUseAntiClockWiseOrder )                                                                      \
         sprintf ( (char*) oszVal, "   %03d %03d %03d ;     /* %d */\n", nV1 + nSTARTVERTINDEX, nV3 + nSTARTVERTINDEX, nV4 + nSTARTVERTINDEX, nPolyNdx );       \
      else                                                                                                 \
         sprintf ( (char*) oszVal, "   %03d %03d %03d ;     /* %d */\n", nV4 + nSTARTVERTINDEX, nV3 + nSTARTVERTINDEX, nV1 + nSTARTVERTINDEX, nPolyNdx );         \
   }                                                                                                         \
   else                                                                                                       \
      if ( nUseAntiClockWiseOrder )                                                                            \
         sprintf ( (char*) oszVal, "   %03d %03d %03d %03d ;     /* %d */\n", nV1 + nSTARTVERTINDEX, nV2 + nSTARTVERTINDEX, nV3 + nSTARTVERTINDEX, nV4 + nSTARTVERTINDEX, nPolyNdx );   \
      else                                                                                                       \
         sprintf ( (char*) oszVal, "   %03d %03d %03d %03d ;     /* %d */\n", nV4 + nSTARTVERTINDEX, nV3 + nSTARTVERTINDEX, nV2 + nSTARTVERTINDEX, nV1 + nSTARTVERTINDEX, nPolyNdx );     \
   oOut.mSetStr ( (char*) oszVal );



/* Make user input
**********************************************************/
void EnterParameters ()
{
   printf ( "Reference system and box walls names: bottom, top, back, front, left, right.
              |y                           
              |
              |                             top   
              |                              .   
              |                              .       
              |                              .       
              |                              .       
     back     *-------------------x          .       
      .      /                               .          
     .      /                              bottom    
    .      /  left . . . . . . right   
   .      /                                 
front    /z                     
                                 
       |y                                     
       |                        
       |
       *---x          
      /
     /z" );
   printf ( "\nFirst box vertex coord (SRU). Is recomendable input the less box point.\n" );
   printf ( "For one valid example enter, when asked: -400, -400, -400\n" );
   printf ( " X: " );
   scanf ( "%f", &fX );
   printf ( " Y: " );
   scanf ( "%f", &fY );
   printf ( " Z: " );
   scanf ( "%f", &fZ );

   printf ( "\n\n
           x
      +--------+
     /|        |
    / |        |z
   +  |        |  
   |  +--------+  
   | /        /
   |/        /y
   +--------+
   " );      
   printf ( "\nDimensions (SRU). Only tested with positive values.\n" );
   printf ( "For one valid example enter, when asked: 800, 800, 800\n" );
   printf ( " X: " );
   scanf ( "%f", &fDIMX );
   printf ( " Y: " );
   scanf ( "%f", &fDIMY );
   printf ( " Z: " );
   scanf ( "%f", &fDIMZ );

   printf ( "\n\n
           x
      +--+--+--+
     /|  |  |  |
    / +--+--+--+ z
      |  |  |  |  
      +--+--+--+  
     /        /
    /        /y
   " );      
   printf ( "\nSteps (amount of space) between vertexes (SRU)\n" );
   printf ( "For one valid example enter, when asked: 200, 200, 200\n" );
   printf ( " X: " );
   scanf ( "%f", &fSTEPX );
   printf ( " Y: " );
   scanf ( "%f", &fSTEPY );
   printf ( " Z: " );
   scanf ( "%f", &fSTEPZ );

   printf ( "\n\n
   +---+   +---+
   |   |   |  /|
   |   |   | / |
   |  4|   |/ 3|
   +---+   +---+
   " );      
   printf ( "\nPolygons\n" );
   printf ( "For one valid example enter, when asked: 4, 4, 4, 4, 4, 4\n" );
   printf ( " on BOTTOM - with 3 or 4 vertexes (enter 3 or 4): " );
   scanf ( "%d", &nNUMVERTPOLY_BOTTOM );
   printf ( " on TOP    - with 3 or 4 vertexes (enter 3 or 4): " );
   scanf ( "%d", &nNUMVERTPOLY_TOP );
   printf ( " on BACK   - with 3 or 4 vertexes (enter 3 or 4): " );
   scanf ( "%d", &nNUMVERTPOLY_BACK );
   printf ( " on FRONT  - with 3 or 4 vertexes (enter 3 or 4): " );
   scanf ( "%d", &nNUMVERTPOLY_FRONT );
   printf ( " on LEFT   - with 3 or 4 vertexes (enter 3 or 4): " );
   scanf ( "%d", &nNUMVERTPOLY_LEFT );
   printf ( " on RIGHT  - with 3 or 4 vertexes (enter 3 or 4): " );
   scanf ( "%d", &nNUMVERTPOLY_RIGHT );

   printf ( "\n\n
   1---2   1---4
   |   |   |   |
   |   |   |   |
   |   |   |   |
   4---3   2---3
   " );      
   printf ( "\nOrder poly vertexes in\n" );
   printf ( "For one valid example enter, when asked: 1\n" );
   printf ( " enter 0 if in clockwise order\n" );
   printf ( " enter 1 if in anticlockwise order." );
   scanf ( "%d", &nUseAntiClockWiseOrder );

   printf ( "\nOutput file\n" );
   printf ( "For one valid example enter, when asked: a.txe, 0, 0, 5, 4\n" );
   printf ( " name: " );
   scanf ( "%s", (char*) oszOUT );
   printf ( " start vertex counting at index: " );
   scanf ( "%d", &nSTARTVERTINDEX );
   printf ( " start polygon counting at index: " );
   scanf ( "%d", &nSTARTPOLYINDEX );
   printf ( " break vertex file listing every vertexes: " );
   scanf ( "%d", &nBREAKVERT );
   printf ( " break polygon file listing every (square) polygons: " );
   scanf ( "%d", &nBREAKPOLY );
}



/* Write TXE header
**********************************************************/
void WriteBegin ( CFile& oOut )
{
   oOut.mSetStr ( "/* Box generated by Box Build.\n\n" );

   oOut.mSetStr ( "Geometrycs parameters\n" );

   CString
      oszStr ( 200 );
   sprintf ( (char*) oszStr, " coords:     %f %f %f\n", fX, fY, fZ );
   oOut.mSetStr ( (char*) oszStr );

   sprintf ( (char*) oszStr, " dimensions: %f %f %f\n", fDIMX, fDIMY, fDIMZ );
   oOut.mSetStr ( (char*) oszStr );

   sprintf ( (char*) oszStr, " steps:      %f %f %f\n", fSTEPX, fSTEPY, fSTEPZ );
   oOut.mSetStr ( (char*) oszStr );

   oOut.mSetStr ( "*/\n\n" );
}



/* Generate and save the box vertexes
**********************************************************/
void WriteBoxVertexes ( CFile& oOut )
{
   printf ( "\nGenerating vertexes...\n" );

   oOut.mSetStr ( STR_OUT_VERTEXES_BEGIN );
   oOut.mSetStr ( "\n\n" );

   INT
      nCount = 0,    // count when break the vertex listing
      nVertNdx = nSTARTVERTINDEX;  // count the vertex index

   // has the output value
   CString
      oszVal ( 200 );

   // bottom

   nCount = 0;
   oOut.mSetStr ( "   /* bottom */\n" );
   
   // scan surface from back to front
   for ( float fcZ = fZ; fcZ < fZ + fDIMZ + fSTEPZ; fcZ += fSTEPZ )

      // scan surface from left to right
      for ( float fcX = fX; fcX < fX + fDIMX + fSTEPX; fcX += fSTEPX ) {

         sprintf ( (char*) oszVal, "   %+09.3f %+09.3f %+09.3f      /* %d */\n", fcX, fY, fcZ, nVertNdx );
         oOut.mSetStr ( (char*) oszVal );
         nVertNdx ++;

         if ( nCount ++ % nBREAKVERT == nBREAKVERT - 1 )
            oOut.mSetStr ( "\n" );
      }

   // top

   nCount = 0;

   oOut.mSetStr ( "\n   /* top */\n" );
   
   // scan surface from back to front
   for ( float fcZ = fZ; fcZ < fZ + fDIMZ + fSTEPZ; fcZ += fSTEPZ )

      // scan surface from left to right
      for ( float fcX = fX; fcX < fX + fDIMX + fSTEPX; fcX += fSTEPX ) {

         sprintf ( (char*) oszVal, "   %+09.3f %+09.3f %+09.3f      /* %d */\n", fcX, fY + fDIMY, fcZ, nVertNdx );
         oOut.mSetStr ( (char*) oszVal );
         nVertNdx ++;

         if ( nCount ++ % nBREAKVERT == nBREAKVERT - 1 )
            oOut.mSetStr ( "\n" );
      }

   // middle

   // middle back
   oOut.mSetStr ( "\n   /* middle back */\n" );
   // scan surface from bottom to top
   for ( float fcY = fY + fSTEPY; fcY < fY + fDIMY; fcY += fSTEPY ) {

      nCount = 0;
      
      // scan surface from left to right
      for ( float fcX = fX; fcX < fX + fDIMX + fSTEPX; fcX += fSTEPX ) {

         sprintf ( (char*) oszVal, "   %+09.3f %+09.3f %+09.3f      /* %d */\n", fcX, fcY, fZ, nVertNdx );
         oOut.mSetStr ( (char*) oszVal );
         nVertNdx ++;

         if ( nCount ++ % nBREAKVERT == nBREAKVERT - 1 )
            oOut.mSetStr ( "\n" );
      }
   }

   // middle front
   // scan surface from bottom to top
   oOut.mSetStr ( "\n   /* middle front */\n" );
   for ( float fcY = fY + fSTEPY; fcY < fY + fDIMY; fcY += fSTEPY ) {

      nCount = 0;
      
      // scan surface from right to left
      for ( float fcX = fX; fcX < fX + fDIMX + fSTEPX; fcX += fSTEPX ) {

         sprintf ( (char*) oszVal, "   %+09.3f %+09.3f %+09.3f      /* %d */\n", ( fDIMX + fX ) - fcX + fX, fcY, fDIMZ + fZ, nVertNdx );
         oOut.mSetStr ( (char*) oszVal );
         nVertNdx ++;

         if ( nCount ++ % nBREAKVERT == nBREAKVERT - 1 )
            oOut.mSetStr ( "\n" );
      }
   }

   // middle left
   oOut.mSetStr ( "\n   /* middle left */\n" );
   // scan surface from bottom to top
   for ( float fcY = fY + fSTEPY; fcY < fY + fDIMY; fcY += fSTEPY ) {

      nCount = 0;

      // scan surface from front to back (is smaller than front wall to
      // avoid vertexes redeclaration)
      for ( float fcZ = fZ + fSTEPZ; fcZ < fZ + fDIMZ; fcZ += fSTEPZ ) {

         sprintf ( (char*) oszVal, "   %+09.3f %+09.3f %+09.3f      /* %d */\n", fX, fcY, ( fDIMZ + fZ ) - fcZ + fZ, nVertNdx );
         oOut.mSetStr ( (char*) oszVal );
         nVertNdx ++;

         if ( nCount ++ % nBREAKVERT == nBREAKVERT - 1 )
            oOut.mSetStr ( "\n" );
      }
   }
   
   // middle right
   oOut.mSetStr ( "\n   /* middle right */\n" );
   // scan surface from bottom to top
   for ( float fcY = fY + fSTEPY; fcY < fY + fDIMY; fcY += fSTEPY ) {

      nCount = 0;
      
      // scan surface from back to front (is smaller than front to avoid
      // vertexes redeclaration)
      for ( float fcZ = fZ + fSTEPZ; fcZ < fZ + fDIMZ; fcZ += fSTEPZ ) {

         sprintf ( (char*) oszVal, "   %+09.3f %+09.3f %+09.3f      /* %d */\n", fX + fDIMX, fcY, fcZ, nVertNdx );
         oOut.mSetStr ( (char*) oszVal );
         nVertNdx ++;

         if ( nCount ++ % nBREAKVERT == nBREAKVERT - 1 )
            oOut.mSetStr ( "\n" );
      }
   }

   oOut.mSetStr ( STR_OUT_VERTEXES_END );
}



/* Generate and save the box polys
**********************************************************/
void WriteBoxPolygons ( CFile& oOut )
{
   printf ( "\nGenerating polygons...\n" );

   oOut.mSetStr ( "\n\n\n" );
   oOut.mSetStr ( STR_OUT_POLYGONS_BEGIN );
   oOut.mSetStr ( "\n\n" );

   INT
      nCount = 0,                  // count when break the poly listing
      nPolyNdx = nSTARTPOLYINDEX,  // count the poly index
      // number of poly in each direction
      nNumPolysX = (INT) ( fDIMX / fSTEPX ),
      nNumPolysY = (INT) ( fDIMY / fSTEPY ),
      nNumPolysZ = (INT) ( fDIMZ / fSTEPZ );

   // the number of polys must be positive
   if ( nNumPolysX < 0 )
      nNumPolysX -= nNumPolysX;
   if ( nNumPolysY < 0 )
      nNumPolysY -= nNumPolysY;
   if ( nNumPolysZ < 0 )
      nNumPolysZ -= nNumPolysZ;

   // define the number of vertexes in each direction
   INT
      nNumVertsX = nNumPolysX + 1,
      nNumVertsY = nNumPolysY + 1,
      nNumVertsZ = nNumPolysZ + 1;

   // has the output value
   CString
      oszVal ( 100 );
      
   // vertexes indexes
   INT
      nV1,
      nV2,
      nV3,
      nV4;

   // bottom

   nCount = 0;
   oOut.mSetStr ( "   /* bottom */\n" );
   
   // scan surface from back to front
   for ( int ncZ = 0; ncZ < nNumPolysZ; ncZ ++ )

      // scan surface from left to right
      for ( int ncX = 0; ncX < nNumPolysX; ncX ++ ) {
      
         // define vertexes indexes (anti-clockwise order)
         nV1 = ( ncX + 0 ) + ( ncZ + 0 ) * nNumVertsX;
         nV2 = ( ncX + 0 ) + ( ncZ + 1 ) * nNumVertsX;
         nV3 = ( ncX + 1 ) + ( ncZ + 1 ) * nNumVertsX;
         nV4 = ( ncX + 1 ) + ( ncZ + 0 ) * nNumVertsX;
         
         WRITE_TO_DISK ( nNUMVERTPOLY_BOTTOM );
         nPolyNdx ++;

         if ( nCount ++ % nBREAKPOLY == nBREAKPOLY - 1 )
            oOut.mSetStr ( "\n" );
      }

   // top

   nCount = 0;
   oOut.mSetStr ( "   /* top */\n" );

   // number of vertexes in bottom, start index for exclusive
   // front wall vertexes (vertexes not in bottom, too)
   INT
      nBaseNdx = nNumVertsX * nNumVertsZ;
   
   // scan surface from back to front
   for ( int ncZ = 0; ncZ < nNumPolysZ; ncZ ++ )

      // scan surface from left to right
      for ( int ncX = 0; ncX < nNumPolysX; ncX ++ ) {
      
         // define vertexes indexes (anti-clockwise order)
         nV1 = ( ncX + 0 ) + ( ncZ + 1 ) * nNumVertsX + nBaseNdx;
         nV2 = ( ncX + 0 ) + ( ncZ + 0 ) * nNumVertsX + nBaseNdx;
         nV3 = ( ncX + 1 ) + ( ncZ + 0 ) * nNumVertsX + nBaseNdx;
         nV4 = ( ncX + 1 ) + ( ncZ + 1 ) * nNumVertsX + nBaseNdx;
         
         WRITE_TO_DISK ( nNUMVERTPOLY_TOP );
         nPolyNdx ++;

         if ( nCount ++ % nBREAKPOLY == nBREAKPOLY - 1 )
            oOut.mSetStr ( "\n" );
      }

   // back

   nCount = 0;
   oOut.mSetStr ( "\n   /* back */\n" );

   // number of vertexes in bottom and top
   nBaseNdx = nNumVertsX * nNumVertsZ * 2;
   
   // scan surface from bottom to top
   for ( int ncY = 0; ncY < nNumPolysY; ncY ++ )

      // scan surface from left to right
      for ( int ncX = 0; ncX < nNumPolysX; ncX ++ ) {

         // define vertexes indexes (anticlockwise order: v1, v2, v3, v4)
         
         // last line of polys use some vertexes from top
         if ( ncY == nNumPolysY - 1 ) {
            nV1 = ( ncX + 0 ) + nNumVertsX * nNumVertsZ;
            nV4 = ( ncX + 1 ) + nNumVertsX * nNumVertsZ;
         }
         else {
            nV1 = ( ncX + 0 ) + ( ncY + 0 ) * nNumVertsX + nBaseNdx;
            nV4 = ( ncX + 1 ) + ( ncY + 0 ) * nNumVertsX + nBaseNdx;
         }

         // first line of polys use some vertexes from bottom
         if ( ncY == 0 ) {
            nV2 = ncX;
            nV3 = ncX + 1;
         }
         else {
            nV2 = ( ncX + 0 ) + ( ncY - 1 ) * nNumVertsX + nBaseNdx;
            nV3 = ( ncX + 1 ) + ( ncY - 1 ) * nNumVertsX + nBaseNdx;
         }
         
         WRITE_TO_DISK ( nNUMVERTPOLY_BACK );
         nPolyNdx ++;

         if ( nCount ++ % nBREAKPOLY == nBREAKPOLY - 1 )
            oOut.mSetStr ( "\n" );
      }

   // front

   nCount = 0;
   oOut.mSetStr ( "\n   /* front */\n" );

   // number of vertexes in bottom, top and back
   nBaseNdx = nNumVertsX * nNumVertsZ * 2 + nNumVertsX * ( nNumVertsY - 2 );
   
   // scan surface from bottom to top
   for ( int ncY = 0; ncY < nNumPolysY; ncY ++ )

      // scan surface from right to left
      for ( int ncX = 0; ncX < nNumPolysX; ncX ++ ) {

         // define vertexes indexes (anticlockwise order: v1, v2, v3, v4)
         
         // last line of polys use some vertexes in top
         if ( ncY == nNumPolysY - 1 ) {
            nV1 = nNumVertsX * nNumVertsZ * 2 - ncX - 1;
            nV4 = nNumVertsX * nNumVertsZ * 2 - ncX - 2;
         }
         else {
            nV1 = ( ncX + 0 ) + ( ncY + 0 ) * nNumVertsX + nBaseNdx;
            nV4 = ( ncX + 1 ) + ( ncY + 0 ) * nNumVertsX + nBaseNdx;
         }

         // first line of polys use some vertexes from bottom
         if ( ncY == 0 ) {
            nV2 = nNumVertsX * nNumVertsZ - 1 - ncX + 0;
            nV3 = nNumVertsX * nNumVertsZ - 1 - ncX - 1;
         }
         else {
            nV2 = ( ncX + 0 ) + ( ncY - 1 ) * nNumVertsX + nBaseNdx;
            nV3 = ( ncX + 1 ) + ( ncY - 1 ) * nNumVertsX + nBaseNdx;
         }
         
         WRITE_TO_DISK ( nNUMVERTPOLY_FRONT );
         nPolyNdx ++;

         if ( nCount ++ % nBREAKPOLY == nBREAKPOLY - 1 )
            oOut.mSetStr ( "\n" );
      }

   // left

   nCount = 0;
   oOut.mSetStr ( "\n   /* left */\n" );

   // number of vertexes in bottom, top, back and front
   nBaseNdx = nNumVertsX * nNumVertsZ * 2 + nNumVertsX * ( nNumVertsY - 2 ) * 2;
   
   // scan surface from bottom to top
   for ( int ncY = 0; ncY < nNumPolysY; ncY ++ )

      // scan surface from front to back
      for ( int ncZ = 0; ncZ < nNumPolysZ; ncZ ++ ) {

         // define vertexes indexes (anticlockwise order: v1, v2, v3, v4)

         // last line of polys use some vertexes from top
         if ( ncY == nNumPolysY - 1 ) {

            // first row, use some vertexes from top
            if ( ncZ == 0 )
               nV1 = nNumVertsX * nNumVertsZ * 2 - nNumVertsX;
            else
               // use vertex from back
               nV1 = nNumVertsX * ( nNumVertsZ - ncZ - 1 ) + nNumVertsZ * nNumVertsX;

            nV4 = nNumVertsX * ( nNumVertsZ - ncZ - 2 ) + nNumVertsZ * nNumVertsX;
         }
         else {
            if ( ncZ == 0 )
               // from back
               nV1 = nNumVertsX * ( ncY + 1 ) - 1 + nNumVertsX * nNumVertsZ * 2 + nNumVertsX * ( nNumVertsY - 2 );
            else
               // from left
               nV1 = ( ncZ - 1 ) + ( ncY + 0 ) * ( nNumVertsZ - 2 ) + nBaseNdx;

            // if last row
            if ( ncZ == nNumPolysZ - 1 )
               // use from front
               nV4 = ( ncY + 0 ) * nNumVertsX + nNumVertsX * nNumVertsZ * 2;
            else
               // use from left
               nV4 = ( ncZ + 0 ) + ( ncY + 0 ) * ( nNumVertsZ - 2 ) + nBaseNdx;
         }
    
         // first line of polys use some vertexes from bottom
         if ( ncY == 0 ) {

            nV2 = nNumVertsX * ( nNumVertsZ - ncZ - 1 );
            nV3 = nNumVertsX * ( nNumVertsZ - ncZ - 2 );
         }
         else {

            // first row, use some vertexes from bottom
            if ( ncZ == 0 )
               // from back
               nV2 = nNumVertsX * ( ncY + 0 ) - 1 + nNumVertsX * nNumVertsZ * 2 + nNumVertsX * ( nNumVertsY - 2 );
            else
               // from left
               nV2 = ( ncZ - 1 ) + ( ncY - 1 ) * ( nNumVertsZ - 2 ) + nBaseNdx;

            // if last row
            if ( ncZ == nNumPolysZ - 1 )
               // from back
               nV3 = ( ncY - 1 ) * nNumVertsX + nNumVertsX * nNumVertsZ * 2;
            else
               // from left
               nV3 = ( ncZ + 0 ) + ( ncY - 1 ) * ( nNumVertsZ - 2 ) + nBaseNdx;
         }
         
         WRITE_TO_DISK ( nNUMVERTPOLY_LEFT );
         nPolyNdx ++;

         if ( nCount ++ % nBREAKPOLY == nBREAKPOLY - 1 )
            oOut.mSetStr ( "\n" );
      }

   // right

   nCount = 0;
   oOut.mSetStr ( "\n   /* right */\n" );

   // number of vertexes in bottom, top, back, front and left
   nBaseNdx = nNumVertsX * nNumVertsZ * 2 + nNumVertsX * ( nNumVertsY - 2 ) * 2 + ( nNumVertsY - 2 ) * ( nNumVertsZ - 2 );
   
   // scan surface from bottom to top
   for ( int ncY = 0; ncY < nNumPolysY; ncY ++ )

      // scan surface from back to front
      for ( int ncZ = 0; ncZ < nNumPolysZ; ncZ ++ ) {

         // define vertexes indexes (anticlockwise order: v1, v2, v3, v4)

         // last line of polys use some vertexes from top
         if ( ncY == nNumPolysY - 1 ) {

            nV1 = nNumVertsX * nNumVertsZ + nNumVertsX  * ( ncZ + 1 ) - 1;
            nV4 = nNumVertsX * nNumVertsZ + nNumVertsX  * ( ncZ + 2 ) - 1;
         }
         else {
            // first row
            if ( ncZ == 0 )
               // from back
               nV1 = nNumVertsX * ( ncY + 1 ) + nNumVertsX * nNumVertsZ * 2 - 1;
            else
               // from right
               nV1 = ( ncZ - 1 ) + ( ncY + 0 ) * ( nNumVertsZ - 2 ) + nBaseNdx;

            // if last row
            if ( ncZ == nNumPolysZ - 1 )
               // use from front
               nV4 = ( ncY + 0 ) * nNumVertsX + nNumVertsX * nNumVertsZ * 2 + nNumVertsX * ( nNumVertsY - 2 );
            else
               // use from right
               nV4 = ( ncZ + 0 ) + ( ncY + 0 ) * ( nNumVertsZ - 2 ) + nBaseNdx;
         }
    
         // first line of polys
         if ( ncY == 0 ) {

            // use some vertexes from bottom
            nV2 = nNumVertsX * ( ncZ + 0 ) - 1 + nNumVertsX;
            nV3 = nNumVertsX * ( ncZ + 1 ) - 1 + nNumVertsX;
         }
         else {

            // if first row
            if ( ncZ == 0 )
               // from back
               nV2 = nNumVertsX * ( ncY + 0 ) + nNumVertsX * nNumVertsZ * 2 - 1;
            else
               // from right
               nV2 = ( ncZ - 1 ) + ( ncY - 1 ) * ( nNumVertsZ - 2 ) + nBaseNdx;

            // if last row
            if ( ncZ == nNumPolysZ - 1 )
               // from front
               nV3 = ( ncY - 1 ) * nNumVertsX + nNumVertsX * nNumVertsZ * 2 + nNumVertsX * ( nNumVertsY - 2 );
            else
               // from right
               nV3 = ( ncZ + 0 ) + ( ncY - 1 ) * ( nNumVertsZ - 2 ) + nBaseNdx;
         }
         
         WRITE_TO_DISK ( nNUMVERTPOLY_RIGHT );
         nPolyNdx ++;

         if ( nCount ++ % nBREAKPOLY == nBREAKPOLY - 1 )
            oOut.mSetStr ( "\n" );
      }

   oOut.mSetStr ( STR_OUT_POLYGONS_END );
}



main ()// INT nNumArgs, char *szArgs [] )
{
   printf ( "Box Build - create a box and save as a TXE file\n" );

   EnterParameters ();

   CFile
      oOut;
   if ( ! oOut.mOpen ( oszOUT, "wt" ) ) {
      printf ( "Error creating file `%s'.\n", (char*) oszOUT );
      return 0;
   }

   WriteBegin ( oOut );

   WriteBoxVertexes ( oOut );

   WriteBoxPolygons ( oOut );

   printf ( "\nTo discover a vertex or poly index is need know the\n" );
   printf ( "walls generation order: bottom - top - back - front - left - right.\n" );
   printf ( "\nTo discover a VERTEX index:\n" );
   printf ( "In bottom wall vertexes are generated in order: back - front, left - right; \n" );
   printf ( " (start at back left - loop to back right, advance to front left - loop to right, ...)\n" );
   printf ( "In top    wall vertexes are generated in order: back - front, left - right; \n" );
   printf ( "In back   wall vertexes are generated in order: bottom - top, left - right; \n" );
   printf ( "In front  wall vertexes are generated in order: bottom - top, right - left; \n" );
   printf ( "In left   wall vertexes are generated in order: bottom - top, front - back; \n" );
   printf ( "In right  wall vertexes are generated in order: bottom - top, back - front. \n" );
   printf ( "Some vertexes are shared (example: bottom and left), the index of\n" );
   printf ( "this vertexes is acording the first wall generated.\n" );

   printf ( "\nTo discover a POLY index:\n" );
   printf ( "In bottom wall polys are generated in order: back - front, left - right; \n" );
   printf ( "In top    wall polys are generated in order: back - front, left - right; \n" );
   printf ( "In back   wall polys are generated in order: bottom - top, left - right; \n" );
   printf ( "In front  wall polys are generated in order: bottom - top, right - left; \n" );
   printf ( "In left   wall polys are generated in order: bottom - top, front - back; \n" );
   printf ( "In right  wall polys are generated in order: bottom - top, back - front. \n" );

   oOut.mClose ();
}
